Imports System.IO
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports System.Threading

Partial Public Class Form1
    Inherits Form
    Public Sub New()
        InitializeComponent()


        txtStartTime.Text = DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss")
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        rBtnIP.Checked = True


    End Sub

#Region "Main"
    Private Sub rBtnIP_CheckedChanged(sender As Object, e As EventArgs) Handles rBtnIP.CheckedChanged
        If rBtnIP.Checked = True Then
            btnConnect.Text = "Connect IP"
            txtCommPort.Visible = False
            lblCommPort.Visible = False
            txtBaudRate.Visible = False
            lblBaudRate.Visible = False
            lblIPAdd.Visible = True
            txtIPAdd.Visible = True
            lblPort.Visible = True
            txtPort.Visible = True
        End If
    End Sub

    Private Sub rBtnCOM_CheckedChanged(sender As Object, e As EventArgs) Handles rBtnCOM.CheckedChanged
        If rBtnCOM.Checked = True Then
            btnConnect.Text = "Connect COMM"
            txtCommPort.Visible = True
            lblCommPort.Visible = True
            txtBaudRate.Visible = True
            lblBaudRate.Visible = True
            lblIPAdd.Visible = False
            txtIPAdd.Visible = False
            lblPort.Visible = False
            txtPort.Visible = False
        End If
    End Sub

    Private Sub rBtnUSB_CheckedChanged(sender As Object, e As EventArgs) Handles rBtnUSB.CheckedChanged
        If rBtnUSB.Checked = True Then
            btnConnect.Text = "Connect"

            lblIPAdd.Visible = False
            lblPort.Visible = False
            lblCommPort.Visible = False
            lblBaudRate.Visible = False
            lblCommKey.Visible = True
            lblModel.Visible = True
            lblDeviceNo.Visible = True

            txtIPAdd.Visible = False
            txtPort.Visible = False
            txtCommPort.Visible = False
            txtBaudRate.Visible = False
            txtCommKey.Visible = True
            txtModel.Visible = True
            txtDeviceNo.Visible = True
        End If
    End Sub

    'make a connection to IP or comm address or USB client
    Private Sub btnConnect_Click(sender As Object, e As EventArgs) Handles btnConnect.Click
        Dim portNo As Integer = 0
        Dim devModel As String = ""
        Dim devNo As Integer = 0
        Dim ipAdd As String = ""
        Dim comm As Integer = 0
        Dim sdkVer As String = ""
        Dim firmware As String = ""
        Dim sdk As String = ""
        Dim firm As String = ""
        Dim time As String = ""

        Dim yr As Integer = 0
        Dim mth As Integer = 0
        Dim day_Renamed As Integer = 0
        Dim hr As Integer = 0
        Dim min As Integer = 0
        Dim sec As Integer = 0
        Dim commPort As Integer = 0
        Dim baudRate As Integer = 0
        Dim i As Integer = 0

        devModel = txtModel.Text
        devNo = Convert.ToInt32(txtDeviceNo.Text)
        ipAdd = txtIPAdd.Text
        portNo = Convert.ToInt32(txtPort.Text)
        comm = Convert.ToInt32(txtCommKey.Text)
        commPort = Convert.ToInt32(txtCommPort.Text)
        baudRate = Convert.ToInt32(txtBaudRate.Text)

        'option to connect to ip address
        If rBtnIP.Checked Then
            If AxBioBridgeSDKv3lib1.Connect_TCPIP(devModel, devNo, ipAdd, portNo, comm) = 0 Then
                RegisterEvent()

                btnConnect.Enabled = False
                btnDisconnect.Enabled = True

                txtIPAdd.Enabled = False
                txtPort.Enabled = False

                If AxBioBridgeSDKv3lib1.GetSDKVersion(sdkVer, 0) = 0 Then
                    sdk = "SDK Version: " & sdkVer
                Else
                    sdk = "SDK Version Error"
                End If

                If AxBioBridgeSDKv3lib1.GetFirmwareVersion(firmware) = 0 Then
                    firm = "Firmware Version: " & firmware
                Else
                    firm = "Firmware Error"
                End If

                If AxBioBridgeSDKv3lib1.GetDeviceTime(yr, mth, day_Renamed, hr, min, sec) = 0 Then
                    time = "Device Date and Time: " & Convert.ToString(day_Renamed) & "/" & Convert.ToString(mth) & "/" & Convert.ToString(yr) & " " & Convert.ToString(hr) & ":" & Convert.ToString(min) & ":" & Convert.ToString(sec)
                Else
                    time = "!Date and Time"
                End If
                List1.Items.Add(("-------------------------------------------------------------------"))
                List1.Items.Add((sdk))
                List1.Items.Add((firm))
                List1.Items.Add((time))
                List1.Items.Add(("Manufacturer: " & AxBioBridgeSDKv3lib1.VC))
                List1.Items.Add(("Serial No: " & AxBioBridgeSDKv3lib1.SN))
                List1.Items.Add(("Mac Add: " & AxBioBridgeSDKv3lib1.MAC))
                List1.Items.Add(("Model Name: " & AxBioBridgeSDKv3lib1.DC))

                If AxBioBridgeSDKv3lib1.Finger10 = 1 Then
                    List1.Items.Add(("This is a FP10 reader"))
                Else
                    List1.Items.Add(("This is not a FP10 reader"))
                End If

                If AxBioBridgeSDKv3lib1.GetDeviceStatus(1, i) = 0 Then
                    List1.Items.Add(("Administrator: " & Convert.ToString(i)))
                End If
                If AxBioBridgeSDKv3lib1.GetDeviceStatus(2, i) = 0 Then
                    List1.Items.Add(("Users: " & Convert.ToString(i)))
                End If
                If AxBioBridgeSDKv3lib1.GetDeviceStatus(3, i) = 0 Then
                    List1.Items.Add(("Fingerprints: " & Convert.ToString(i)))
                End If
                If AxBioBridgeSDKv3lib1.GetDeviceStatus(4, i) = 0 Then
                    List1.Items.Add(("Passwords: " & Convert.ToString(i)))
                End If
                If AxBioBridgeSDKv3lib1.GetDeviceStatus(6, i) = 0 Then
                    List1.Items.Add(("Logs: " & Convert.ToString(i)))
                End If




                List1.Items.Add(("------------------------------------------------------------------"))
            Else
                List1.Items.Add(("Unable to Connect to IP Address!!"))
                List1.Items.Add(("Error: " & AxBioBridgeSDKv3lib1.VC))
            End If
        End If

        'option to connect to COMM Port
        If rBtnCOM.Checked Then
            If AxBioBridgeSDKv3lib1.Connect_COMM(devModel, devNo, commPort, baudRate, comm) = 0 Then
                RegisterEvent()

                btnConnect.Enabled = False
                btnDisconnect.Enabled = True

                txtBaudRate.Enabled = False
                txtCommPort.Enabled = False

                If AxBioBridgeSDKv3lib1.GetSDKVersion(sdkVer, 0) = 0 Then
                    sdk = "SDK Version: " & sdkVer
                Else
                    sdk = "SDK Version Error"
                End If

                If AxBioBridgeSDKv3lib1.GetFirmwareVersion(firmware) = 0 Then
                    firm = "Firmware Version: " & firmware
                Else
                    firm = "Firmware Error"
                End If

                If AxBioBridgeSDKv3lib1.GetDeviceTime(yr, mth, day_Renamed, hr, min, sec) = 0 Then
                    time = "Device Date and Time: " & Convert.ToString(day_Renamed) & "/" & Convert.ToString(mth) & "/" & Convert.ToString(yr) & " " & Convert.ToString(hr) & ":" & Convert.ToString(min) & ":" & Convert.ToString(sec)
                Else
                    time = "!Date and Time"
                End If
                List1.Items.Add(("-------------------------------------------------------------------"))
                List1.Items.Add((sdk))
                List1.Items.Add((firm))
                List1.Items.Add((time))
                List1.Items.Add(("Manufacturer: " & AxBioBridgeSDKv3lib1.VC))
                List1.Items.Add(("Serial No: " & AxBioBridgeSDKv3lib1.SN))
                List1.Items.Add(("Mac Add: " & AxBioBridgeSDKv3lib1.MAC))
                List1.Items.Add(("Model Name: " & AxBioBridgeSDKv3lib1.DC))

                'if (axBioBridgeSDKv3lib1.Finger10 == 1)
                '{
                '    List1.Items.Add(("This is a FP10 reader"));
                '}
                'else
                '{
                '    List1.Items.Add(("This is not a FP10 reader"));
                '}

                If AxBioBridgeSDKv3lib1.GetDeviceStatus(1, i) = 0 Then
                    List1.Items.Add(("Administrator: " & Convert.ToString(i)))
                End If
                If AxBioBridgeSDKv3lib1.GetDeviceStatus(2, i) = 0 Then
                    List1.Items.Add(("Users: " & Convert.ToString(i)))
                End If
                If AxBioBridgeSDKv3lib1.GetDeviceStatus(3, i) = 0 Then
                    List1.Items.Add(("Fingerprints: " & Convert.ToString(i)))
                End If
                If AxBioBridgeSDKv3lib1.GetDeviceStatus(4, i) = 0 Then
                    List1.Items.Add(("Passwords: " & Convert.ToString(i)))
                End If
                If AxBioBridgeSDKv3lib1.GetDeviceStatus(6, i) = 0 Then
                    List1.Items.Add(("Logs: " & Convert.ToString(i)))
                End If

                List1.Items.Add(("------------------------------------------------------------------"))
            Else
                List1.Items.Add(("Unable to Connect to COMM Port!!"))
                List1.Items.Add(("Error: " & AxBioBridgeSDKv3lib1.VC))
            End If
        End If

        'option to connect to USB Client
        If rBtnUSB.Checked Then
            If AxBioBridgeSDKv3lib1.Connect_USB(devModel, devNo, comm) = 0 Then
                btnConnect.Enabled = False
                btnDisconnect.Enabled = True

                txtIPAdd.Enabled = False
                txtPort.Enabled = False

                If AxBioBridgeSDKv3lib1.GetSDKVersion(sdkVer, 0) = 0 Then
                    sdk = "SDK Version: " & sdkVer
                Else
                    sdk = "SDK Version Error"
                End If

                If AxBioBridgeSDKv3lib1.GetFirmwareVersion(firmware) = 0 Then
                    firm = "Firmware Version: " & firmware
                Else
                    firm = "Firmware Error"
                End If

                If AxBioBridgeSDKv3lib1.GetDeviceTime(yr, mth, day_Renamed, hr, min, sec) = 0 Then
                    time = "Device Date and Time: " & Convert.ToString(day_Renamed) & "/" & Convert.ToString(mth) & "/" & Convert.ToString(yr) & " " & Convert.ToString(hr) & ":" & Convert.ToString(min) & ":" & Convert.ToString(sec)
                Else
                    time = "!Date and Time"
                End If
                List1.Items.Add(("-------------------------------------------------------------------"))
                List1.Items.Add((sdk))
                List1.Items.Add((firm))
                List1.Items.Add((time))
                List1.Items.Add(("Manufacturer: " & AxBioBridgeSDKv3lib1.VC))
                List1.Items.Add(("Serial No: " & AxBioBridgeSDKv3lib1.SN))
                List1.Items.Add(("Mac Add: " & AxBioBridgeSDKv3lib1.MAC))
                List1.Items.Add(("Model Name: " & AxBioBridgeSDKv3lib1.DC))

                If AxBioBridgeSDKv3lib1.Finger10 = 1 Then
                    List1.Items.Add(("This is a FP10 reader"))
                Else
                    List1.Items.Add(("This is not a FP10 reader"))
                End If

                If AxBioBridgeSDKv3lib1.GetDeviceStatus(1, i) = 0 Then
                    List1.Items.Add(("Administrator: " & Convert.ToString(i)))
                End If
                If AxBioBridgeSDKv3lib1.GetDeviceStatus(2, i) = 0 Then
                    List1.Items.Add(("Users: " & Convert.ToString(i)))
                End If
                If AxBioBridgeSDKv3lib1.GetDeviceStatus(3, i) = 0 Then
                    List1.Items.Add(("Fingerprints: " & Convert.ToString(i)))
                End If
                If AxBioBridgeSDKv3lib1.GetDeviceStatus(4, i) = 0 Then
                    List1.Items.Add(("Passwords: " & Convert.ToString(i)))
                End If
                If AxBioBridgeSDKv3lib1.GetDeviceStatus(6, i) = 0 Then
                    List1.Items.Add(("Logs: " & Convert.ToString(i)))
                End If

                List1.Items.Add(("------------------------------------------------------------------"))
            Else
                List1.Items.Add(("Unable to Connect to IP Address!!"))
                List1.Items.Add(("Error: " & AxBioBridgeSDKv3lib1.VC))
            End If
        End If
    End Sub

    Private Sub RegisterEvent()
        AddHandler AxBioBridgeSDKv3lib1.OnConnect, New EventHandler(AddressOf axBioBridgeSDKv3lib1_OnConnect)
        AddHandler AxBioBridgeSDKv3lib1.OnDisConnect, New EventHandler(AddressOf axBioBridgeSDKv3lib1_OnDisconnect)
        AddHandler AxBioBridgeSDKv3lib1.OnFinger, New EventHandler(AddressOf axBioBridgeSDKv3lib1_OnFinger)
        AddHandler AxBioBridgeSDKv3lib1.OnAttTransactionEx, New AxBioBridgeSDKv3.IBioBridgeSDKv3libEvents_OnAttTransactionExEventHandler(AddressOf axBioBridgeSDKv3lib1_OnAttTransactionEx)
        AddHandler AxBioBridgeSDKv3lib1.OnDoor, New AxBioBridgeSDKv3.IBioBridgeSDKv3libEvents_OnDoorEventHandler(AddressOf axBioBridgeSDKv3lib1_OnDoor)
        AddHandler AxBioBridgeSDKv3lib1.OnAlarm, New AxBioBridgeSDKv3.IBioBridgeSDKv3libEvents_OnAlarmEventHandler(AddressOf axBioBridgeSDKv3lib1_OnAlarm)
    End Sub

    Private Delegate Sub SetListBox3Callback(ByVal text As String)

    Private Sub ThreadProcSafe(ByVal text As String)
        ' Wait two seconds to simulate some background work
        ' being done.
        Thread.Sleep(2000)

        ' Check if this method is running on a different thread
        ' than the thread that created the control.
        If Me.listBox3.InvokeRequired Then
            ' It's on a different thread, so use Invoke.
            Dim d As New SetListBox3Callback(AddressOf addItem)
            Me.Invoke(d, New Object() {text})
        Else
            ' It's on the same thread, no need for Invoke
            Me.listBox3.Items.Add(text)
        End If
    End Sub
    ' This method is passed in to the SetListBox3Callback delegate
    ' to add the Text property of listBox3.
    Private Sub addItem(ByVal text As String)
        Me.listBox3.Items.Add(text)
    End Sub

    Private Sub axBioBridgeSDKv3lib1_OnAlarm(sender As Object, e As AxBioBridgeSDKv3.IBioBridgeSDKv3libEvents_OnAlarmEvent)
        listBox3.Items.Add("On Alarm Event:- Alarm Type=" & e.alarmType & " ,EnrollNo=" & e.enrollNo & ", Verified=" & e.verified & "")
    End Sub

    Private Sub axBioBridgeSDKv3lib1_OnDoor(sender As Object, e As AxBioBridgeSDKv3.IBioBridgeSDKv3libEvents_OnDoorEvent)
        listBox3.Items.Add("On Door Event:- Event Type=" & e.eventType)
    End Sub

    Private Sub axBioBridgeSDKv3lib1_OnAttTransactionEx(sender As Object, e As AxBioBridgeSDKv3.IBioBridgeSDKv3libEvents_OnAttTransactionExEvent)
        Dim [date] As String = e.year & "-" & e.month & "-" & e.day & " " & e.hour & ":" & e.minute & ":" & e.second
        Dim strMessage As String = String.Empty
        strMessage = "On Transaction Event:- Date=" & [date] & " ,EnrollNo=" & e.enrollNo & " ,AttState=" & e.attState & " ,IsInValid=" & e.isInValid & " ,VerifyMode=" & e.verifyMode & " ,WorkCode=" & e.workCode
        ThreadProcSafe(strMessage)
    End Sub

    Private Sub axBioBridgeSDKv3lib1_OnFinger(sender As Object, e As EventArgs)
        listBox3.Items.Add("On Finger Event!!!")
    End Sub

    Private Sub axBioBridgeSDKv3lib1_OnDisconnect(sender As Object, e As EventArgs)
        listBox3.Items.Add("On Disconnect!!!")
    End Sub

    Private Sub axBioBridgeSDKv3lib1_OnConnect(sender As Object, e As EventArgs)
        listBox3.Items.Add("On Connect!!!")
    End Sub

    'function to disconnect from the device
    Private Sub btnDisconnect_Click(sender As Object, e As EventArgs) Handles btnDisconnect.Click
        txtCommKey.Enabled = True
        txtCommPort.Enabled = True
        txtBaudRate.Enabled = True
        txtIPAdd.Enabled = True
        txtPort.Enabled = True

        btnConnect.Enabled = True
        btnDisconnect.Enabled = False

        If AxBioBridgeSDKv3lib1.Disconnect() = 0 Then
            List1.Items.Add(("Disconnect from Device"))
        Else
            List1.Items.Add(("Unable to disconnect!"))
        End If
    End Sub

    'function to set the comm key device
    Private Sub btnSetComm_Click(sender As Object, e As EventArgs) Handles btnSetComm.Click
        Dim comm As Integer
        comm = Convert.ToInt32(txtCommKey.Text)

        If AxBioBridgeSDKv3lib1.SetDeviceCommKey(comm) = 0 Then
            MessageBox.Show("Done")
        Else
            MessageBox.Show("Failed")
        End If
    End Sub

    Private Sub btnAdvance_Click(sender As Object, e As EventArgs) Handles btnAdvance.Click
        Dim i As Integer = 0
        Dim m As Integer = 0
        Dim h As Integer = 0

        'Date format
        If AxBioBridgeSDKv3lib1.GetDeviceInfo(34, i) = 0 Then
            If i = 0 Then
                List1.Items.Add(("DateFormat : YY-MM-DD"))
            ElseIf i = 1 Then
                List1.Items.Add(("DateFormat : YY/MM/DD"))
            ElseIf i = 2 Then
                List1.Items.Add(("DateFormat : YY.MM.DD"))
            ElseIf i = 3 Then
                List1.Items.Add(("DateFormat : MM-DD-YY"))
            ElseIf i = 4 Then
                List1.Items.Add(("DateFormat : MM/DD/YY"))
            ElseIf i = 5 Then
                List1.Items.Add(("DateFormat : MM.DD.YY"))
            ElseIf i = 6 Then
                List1.Items.Add(("DateFormat : DD-MM-YY"))
            ElseIf i = 7 Then
                List1.Items.Add(("DateFormat : DD/MM/YY"))
            ElseIf i = 8 Then
                List1.Items.Add(("DateFormat : DD.MM.YY"))
            ElseIf i = 9 Then
                List1.Items.Add(("DateFormat : YYYYMMDD"))
            End If
        End If

        'Voice
        If AxBioBridgeSDKv3lib1.GetDeviceInfo(16, i) = 0 Then
            If i = 0 Then
                List1.Items.Add(("Voice : Off"))
            Else
                List1.Items.Add(("Voice : On"))
            End If
        End If

        '1 to N
        If AxBioBridgeSDKv3lib1.GetDeviceInfo(23, i) = 0 Then
            List1.Items.Add(("1 to N :" & Convert.ToString(i)))
        End If

        '1 to 1
        If AxBioBridgeSDKv3lib1.GetDeviceInfo(25, i) = 0 Then
            List1.Items.Add(("1 to 1 :" & Convert.ToString(i)))
        End If

        'Only 1 to 1
        If AxBioBridgeSDKv3lib1.GetDeviceInfo(35, i) = 0 Then
            If i = 0 Then
                List1.Items.Add(("Only 1 to 1 : Off"))
            Else
                List1.Items.Add(("Only 1 to 1 : On"))
            End If
        End If

        'Idle minutes 0-999
        If AxBioBridgeSDKv3lib1.GetDeviceInfo(4, i) = 0 Then
            List1.Items.Add(("Idle Minutes : " & Convert.ToString(i)))
        End If

        'Idle Action
        If AxBioBridgeSDKv3lib1.GetDeviceInfo(18, i) = 0 Then
            If i = 87 Then
                List1.Items.Add(("Idle Action : Power Off"))
            ElseIf i = 88 Then
                List1.Items.Add(("Idle Action : Sleep Mode"))
            End If
        End If

        'Lock Delay
        If AxBioBridgeSDKv3lib1.GetDeviceInfo(5, i) = 0 Then
            List1.Items.Add(("Lock Delay : " & Convert.ToString(i) & " (*200ms)"))
        End If

        'Total Faces
        If AxBioBridgeSDKv3lib1.GetDeviceInfo(21, i) = 0 Then
            List1.Items.Add(("Face Template : " & Convert.ToString(i)))
        End If

        'Face Capacity
        If AxBioBridgeSDKv3lib1.GetDeviceInfo(22, i) = 0 Then
            List1.Items.Add(("Face Capacity : " & Convert.ToString(i)))
        End If

        'Sleep Time
        If AxBioBridgeSDKv3lib1.GetSleep(h, m) = 0 Then
            List1.Items.Add(("Sleep Time = " & Convert.ToString(h) & ":" & Convert.ToString(m)))
        End If

        'Power Off Time
        If AxBioBridgeSDKv3lib1.GetPowerOff(h, m) = 0 Then
            List1.Items.Add(("Power Off Time = " & Convert.ToString(h) & ":" & Convert.ToString(m)))
        End If

        'Power On Time
        If AxBioBridgeSDKv3lib1.GetPowerOn(h, m) = 0 Then
            List1.Items.Add(("Power On Time = " & Convert.ToString(h) & ":" & Convert.ToString(m)))
        End If

    End Sub

    Private Sub btnRestart_Click(sender As Object, e As EventArgs) Handles btnRestart.Click
        List1.Items.Add(("Device is restarting..."))
        AxBioBridgeSDKv3lib1.RestartDevice()
    End Sub

    'function to unlock the door connected to the device
    Private Sub btnUnlockDoor_Click(sender As Object, e As EventArgs) Handles btnUnlockDoor.Click
        Dim delay As Integer = 1000

        If AxBioBridgeSDKv3lib1.UnlockDoor(delay) = 0 Then
            List1.Items.Add(("Door Unlocked"))
        Else
            List1.Items.Add(("Unable to Unlock Door"))
        End If
    End Sub

    Private Sub btnDisWithTimeOut_Click(sender As Object, e As EventArgs) Handles btnDisWithTimeOut.Click
        If AxBioBridgeSDKv3lib1.DisableDeviceWithTimeout(Convert.ToInt32(txtTimeOut.Text)) = 0 Then
            List1.Items.Add(("Disable Device with Timeout Success"))
        Else
            List1.Items.Add(("DisableDeviceWithTimeout fail"))
        End If
    End Sub

    'function to enable / disable the device
    Private Sub chkEnable_CheckStateChanged(sender As Object, e As EventArgs) Handles chkEnable.CheckedChanged
        If chkEnable.CheckState = 0 Then
            If AxBioBridgeSDKv3lib1.EnableDevice() = 0 Then
                List1.Items.Add(("Device Enabled"))
                chkEnable.Text = "Enable / Disable"
            End If
        Else
            If AxBioBridgeSDKv3lib1.DisableDevice() = 0 Then
                List1.Items.Add(("Device Disabled"))
                chkEnable.Text = "Disable Device"
            End If
        End If
    End Sub

    ' get is color screen model
    Private Sub btnIsTFT_Click(sender As Object, e As EventArgs) Handles btnIsTFT.Click
        If AxBioBridgeSDKv3lib1.IsTFT() = 0 Then
            List1.Items.Add(("Is Color Screen Model"))
        Else
            List1.Items.Add(("Is Black and White Model"))
        End If
    End Sub


    'function to get the date and time from the device
    Private Sub btnGetTime_Click(sender As Object, e As EventArgs) Handles btnGetTime.Click
        Dim yr As Integer = 0
        Dim mth As Integer = 0
        Dim day_Renamed As Integer = 0
        Dim hr As Integer = 0
        Dim min As Integer = 0
        Dim sec As Integer = 0

        If AxBioBridgeSDKv3lib1.GetDeviceTime(yr, mth, day_Renamed, hr, min, sec) = 0 Then
            txtDay.Text = Convert.ToString(day_Renamed)
            txtMonth.Text = Convert.ToString(mth)
            txtYear.Text = Convert.ToString(yr)
            txtHour.Text = Convert.ToString(hr)
            txtMinute.Text = Convert.ToString(min)
            txtSecond.Text = Convert.ToString(sec)

            List1.Items.Add(("Time: " & Convert.ToString(hr) & ":" & Convert.ToString(min) & ":" & Convert.ToString(sec)))
            List1.Items.Add(("Date: " & Convert.ToString(day_Renamed) & "/" & Convert.ToString(mth) & "/" & Convert.ToString(yr)))
        Else
            List1.Items.Add(("No item found!"))
        End If
    End Sub

    'function to set the date and time to the device
    Private Sub btnSetTime_Click(sender As Object, e As EventArgs) Handles btnSetTime.Click
        'assign the field values to variables
        Dim yr As Integer = Convert.ToInt32(txtYear.Text)
        Dim mth As Integer = Convert.ToInt32(txtMonth.Text)
        Dim day_Renamed As Integer = Convert.ToInt32(txtDay.Text)
        Dim hr As Integer = Convert.ToInt32(txtHour.Text)
        Dim min As Integer = Convert.ToInt32(txtMinute.Text)
        Dim sec As Integer = Convert.ToInt32(txtSecond.Text)

        If AxBioBridgeSDKv3lib1.SetDeviceTime(yr, mth, day_Renamed, hr, min, sec) = 0 Then
            List1.Items.Add(("-------------------------------------------------------"))
            List1.Items.Add(("Update Date and Time Done"))
            List1.Items.Add(("Time: " & Convert.ToString(hr) & ":" & Convert.ToString(min) & ":" & Convert.ToString(sec)))
            List1.Items.Add(("Date: " & Convert.ToString(day_Renamed) & "/" & Convert.ToString(mth) & "/" & Convert.ToString(yr)))
            List1.Items.Add(("-------------------------------------------------------"))
        Else
            List1.Items.Add(("Unable to Change Date and Time!!"))
        End If
    End Sub

    'sync the device date and time according to the computer
    Private Sub btnSyncTime_Click(sender As Object, e As EventArgs) Handles btnSyncTime.Click
        If AxBioBridgeSDKv3lib1.SetDeviceTimeLocal() = 0 Then
            List1.Items.Add(("Date and Time Synchronize Done"))
        Else
            List1.Items.Add(("Unable to Sync!!"))
        End If
    End Sub

    'function to read all the user information from the device
    Private Sub btnReadUserData_Click(sender As Object, e As EventArgs) Handles btnReadUserData.Click
        Dim record As Integer = 0
        Dim enrollNo As Integer = 0

        Dim name_Renamed As String = ""
        Dim pwd As String = ""
        Dim priv As Integer = 0
        Dim enable As [Boolean] = False

        'read the user information from device into the memory buffer
        If AxBioBridgeSDKv3lib1.ReadAllUserInfo(record) = 0 Then
            Do
                List1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & "Name: " & name_Renamed & "Pwd: " & pwd & "Enable: " & Convert.ToString(enable)))
            Loop While AxBioBridgeSDKv3lib1.GetAllUserInfo(enrollNo, name_Renamed, pwd, priv, enable) = 0
        Else
            List1.Items.Add(("No Record Found!!"))
        End If
    End Sub

    'function to read all the information log device
    Private Sub btnReadLog_Click(sender As Object, e As EventArgs) Handles btnReadLog.Click
        Dim yr As Integer = 0
        Dim mth As Integer = 0
        Dim day_Renamed As Integer = 0
        Dim hr As Integer = 0
        Dim min As Integer = 0
        Dim sec As Integer = 0

        Dim enrollNo As Integer = 0
        Dim ver As Integer = 0
        Dim io As Integer = 0
        Dim work As Integer = 0
        Dim log As Integer = 0

        AxBioBridgeSDKv3lib1.SetLastCount(Convert.ToInt32(txtSetLastCount.Text))

        If AxBioBridgeSDKv3lib1.ReadGeneralLog(log) = 0 Then
            Do
                List1.Items.Add(("No: " & Convert.ToString(enrollNo) & " Date:" & Convert.ToString(day_Renamed) & "/" & Convert.ToString(mth) & "/" & Convert.ToString(yr) & " Time: " & Convert.ToString(hr) & ":" & Convert.ToString(min) & ":" & Convert.ToString(sec) & " Verify: " & Convert.ToString(ver) & " I/O: " & Convert.ToString(io) & " Work Code: " & Convert.ToString(work)))
            Loop While AxBioBridgeSDKv3lib1.GetGeneralLog(enrollNo, yr, mth, day_Renamed, hr, min,
             sec, ver, io, work) = 0
        Else
            List1.Items.Add(("Unable to Read General Log!!"))
        End If
    End Sub

    'function to clear all the user information in the device
    Private Sub btnClearUserData_Click(sender As Object, e As EventArgs) Handles btnClearUserData.Click
        If AxBioBridgeSDKv3lib1.ClearAllData() = 0 Then
            List1.Items.Add(("All Data Cleared"))
        Else
            List1.Items.Add(("Unable to Clear!!"))
        End If
    End Sub

    'function to clear all the logs in the device
    Private Sub btnClearLog_Click(sender As Object, e As EventArgs) Handles btnClearLog.Click
        If AxBioBridgeSDKv3lib1.DeleteGeneralLog() = 0 Then
            List1.Items.Add(("All Logs Cleared"))
        Else
            List1.Items.Add(("Unable to Clear!!"))
        End If
    End Sub

    Private Sub btnClearAllFields_Click(sender As Object, e As EventArgs) Handles btnClearAllFields.Click
        'Frame2
        txtDay.Text = ""
        txtMonth.Text = ""
        txtYear.Text = ""
        txtHour.Text = ""
        txtMinute.Text = ""
        txtSecond.Text = ""

        'Frame4
        txtEnrollNo.Text = ""
        txtName.Text = ""
        txtPassword.Text = ""
        txtPrivilege.Text = ""

        'Frame5
        txtEnrollNoFinger.Text = ""
        txtFingerIndex.Text = ""
        txtFingerprintTemplate.Text = ""

        'Frame6
        txtEnrollNoTimezone.Text = ""
        txtGroupNo.Text = ""
        txtTimeZoneInfo.Text = ""
        txtTimeZoneNo.Text = ""
        txtTimeZoneStr.Text = ""
        txtUnlockGroup.Text = ""

        'Frame7
        txtEnrollNoUSB.Text = ""
        txtNameUSB.Text = ""
        txtPasswordUSB.Text = ""
        txtTimeZoneGUSB.Text = ""
        txtTimeZoneInfoUSB.Text = ""
        txtFingerIndexUSB.Text = ""
        txtRecordSize.Text = ""
        txtPriviledgeUSB.Text = ""
        txtFilename.Text = ""
        txtFingerTemplateUSB.Text = ""
    End Sub

    'function to clear all the administrator status
    Private Sub btnClearAdmin_Click(sender As Object, e As EventArgs) Handles btnClearAdmin.Click
        If AxBioBridgeSDKv3lib1.ClearAdministrator() = 0 Then
            List1.Items.Add(("All Admin Status Cleared"))
        Else
            List1.Items.Add(("Unable to Clear Admin Status!!"))
        End If
    End Sub

    'function to get the user information based on the enrollment number
    Private Sub btnGetUserInfo_Click(sender As Object, e As EventArgs) Handles btnGetUserInfo.Click
        Dim enrollNo As Integer = 0
        Dim name_Renamed As String = ""
        Dim pwd As String = ""
        Dim level As Integer = 0
        Dim cardNo As String = ""
        Dim status As [Boolean] = False

        If txtEnrollNo.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No!!")
        Else
            enrollNo = Convert.ToInt32(txtEnrollNo.Text)
            If AxBioBridgeSDKv3lib1.GetUserInfo(enrollNo, name_Renamed, pwd, level, status) = 0 Then
                txtName.Text = name_Renamed
                txtPassword.Text = pwd
                txtPrivilege.Text = Convert.ToString(level)
                cmbEnabled.Text = Convert.ToString(status)
                'cardNo = axBioBridgeSDKv3lib1.CardNo;
                'axBioBridgeSDKv3lib1.GetCardNo(cardNo);
                'txtCardNo.Text = Convert.ToString(cardNo);
                AxBioBridgeSDKv3lib1.GetCardNo(cardNo)
                txtCardNo.Text = cardNo
                List1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & " Name: " & name_Renamed & " Pwd: " & pwd & " Privilege: " & Convert.ToString(level) & " Enabled: " & Convert.ToString(status) & " CardNo: " & Convert.ToString(cardNo)))
            Else
                List1.Items.Add(("No Record Found!!"))
            End If
        End If
    End Sub

    'function to set / update the user information
    Private Sub btnSetUserInfo_Click(sender As Object, e As EventArgs) Handles btnSetUserInfo.Click
        Dim enrollNo As Integer = 0
        Dim level As Integer = 0
        Dim name_Renamed As String = ""
        Dim pwd As String = ""
        Dim cardNo As Integer = 0
        Dim status As [Boolean] = False

        If txtEnrollNo.Text = "" OrElse txtPrivilege.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No or Privilege!!")
        Else
            enrollNo = Convert.ToInt32(txtEnrollNo.Text)
            name_Renamed = txtName.Text
            pwd = txtPassword.Text
            level = Convert.ToInt32(txtPrivilege.Text)
            status = Convert.ToBoolean(cmbEnabled.Text)
            cardNo = Convert.ToInt32(txtCardNo.Text)
            AxBioBridgeSDKv3lib1.SetCardNo(cardNo.ToString())
            ' = cardNo;
            If AxBioBridgeSDKv3lib1.SetUserInfo(enrollNo, name_Renamed, pwd, level, status) = 0 Then
                List1.Items.Add(("User Information Set"))
                List1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & " Name: " & name_Renamed & " Pwd: " & pwd & " Privilege: " & Convert.ToString(level) & " Enabled: " & Convert.ToString(status) & " CardNo: " & Convert.ToString(cardNo)))
            Else
                List1.Items.Add(("No Record Found!!"))
            End If
        End If
    End Sub

    'function to delete user information based on the enrollment number
    Private Sub btnDeleteUserInfo_Click(sender As Object, e As EventArgs) Handles btnDeleteUserInfo.Click
        Dim enrollNo As Integer = 0

        If txtEnrollNo.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No!!")
        Else
            enrollNo = Convert.ToInt32(txtEnrollNo.Text)

            If AxBioBridgeSDKv3lib1.DeleteUserData(enrollNo) = 0 Then
                List1.Items.Add(("User Information Removed"))
            Else
                List1.Items.Add(("Unable to Remove User!!"))
            End If
        End If
    End Sub

    'function to get the user fingerprint template based on the user enrollment number
    Private Sub btnGetTemplate_Click(sender As Object, e As EventArgs) Handles btnGetTemplate.Click
        Dim enrollNo As Integer = 0
        Dim fingerId As Integer = 0
        Dim template As String = ""

        If txtEnrollNoFinger.Text = "" OrElse txtFingerIndex.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No or Finger Index No!!")
        Else
            enrollNo = Convert.ToInt32(txtEnrollNoFinger.Text)
            fingerId = Convert.ToInt32(txtFingerIndex.Text)

            If AxBioBridgeSDKv3lib1.GetUserTemplate(enrollNo, fingerId, template) = 0 Then
                List1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & " Index Finger: " & Convert.ToString(fingerId) & " Template: " & template))
                txtFingerprintTemplate.Text = template
            Else
                List1.Items.Add(("No User Record Found!!"))
            End If
        End If
    End Sub

    'function to set / update user fingerprint template
    Private Sub btnSetTemplate_Click(sender As Object, e As EventArgs) Handles btnSetTemplate.Click
        Dim enrollNo As Integer = 0
        Dim fingerId As Integer = 0
        Dim template As String = ""

        If txtEnrollNoFinger.Text = "" OrElse txtFingerIndex.Text = "" OrElse txtFingerprintTemplate.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No or Finger Index No or Template!!")
        Else
            enrollNo = Convert.ToInt32(txtEnrollNoFinger.Text)
            fingerId = Convert.ToInt32(txtFingerIndex.Text)
            template = txtFingerprintTemplate.Text

            If AxBioBridgeSDKv3lib1.SetUserTemplate(enrollNo, fingerId, template) = 0 Then

                List1.Items.Add(("User Fingerprint Template Set"))
            Else
                List1.Items.Add(("Unable to Set Fingerprint Template!!"))
            End If
        End If
    End Sub

    'function to delete user fingerprint template based on the enrollment number and finger id
    Private Sub btnDeleteTemplate_Click(sender As Object, e As EventArgs) Handles btnDeleteTemplate.Click
        Dim fingerId As Integer = 0
        Dim enrollNo As Integer = 0

        If txtEnrollNoFinger.Text = "" OrElse txtFingerIndex.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No or Finger Index No!!")
        Else
            enrollNo = Convert.ToInt32(txtEnrollNoFinger.Text)
            fingerId = Convert.ToInt32(txtFingerIndex.Text)

            If AxBioBridgeSDKv3lib1.DeleteUserTemplate(enrollNo, fingerId) = 0 Then
                List1.Items.Add(("Fingerprint Template Removed"))
            Else
                List1.Items.Add(("Unable to Remove!!"))
            End If
        End If
    End Sub

    'function to get the user group number based on the enrollment number
    Private Sub btnGetUsergroup_Click(sender As Object, e As EventArgs) Handles btnGetUsergroup.Click
        Dim enrollNo As Integer = 0
        Dim groupNo As Integer = 0

        If txtEnrollNoTimezone.Text = "" Then
            MessageBox.Show("Required Field: Enroll No!!")
        Else
            enrollNo = Convert.ToInt32(txtEnrollNoTimezone.Text)

            If AxBioBridgeSDKv3lib1.GetUserGroup(enrollNo, groupNo) = 0 Then
                List1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & " Group No: " & Convert.ToString(groupNo)))
                txtGroupNo.Text = Convert.ToString(groupNo)
            Else
                List1.Items.Add(("Record Not Found!!"))
            End If
        End If
    End Sub

    'function to set / update the user group number
    Private Sub btnSetUsergroup_Click(sender As Object, e As EventArgs) Handles btnSetUsergroup.Click
        Dim enrollNo As Integer = 0
        Dim groupNo As Integer = 0

        If txtEnrollNoTimezone.Text = "" OrElse txtGroupNo.Text = "" Then
            MessageBox.Show("Required Field: Enroll No or Group No!!")
        Else
            enrollNo = Convert.ToInt32(txtEnrollNoTimezone.Text)
            groupNo = Convert.ToInt32(txtGroupNo.Text)

            If AxBioBridgeSDKv3lib1.SetUserGroup(enrollNo, groupNo) = 0 Then
                List1.Items.Add(("Group No Set"))
            Else
                List1.Items.Add(("Unable to Set Group No!!"))
            End If
        End If
    End Sub

    'get the user timezone based on the enrollment number
    Private Sub btnGetTimeZone_Click(sender As Object, e As EventArgs) Handles btnGetTimeZone.Click
        Dim enrollNo As Integer = 0
        Dim timeZone As String = ""

        If txtEnrollNoTimezone.Text = "" Then
            MessageBox.Show("Required Field: Enroll No!!")
        Else
            enrollNo = Convert.ToInt32(txtEnrollNoTimezone.Text)

            If AxBioBridgeSDKv3lib1.GetUserTimezone(enrollNo, timeZone) = 0 Then
                List1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & " Group No: " & timeZone))
                txtTimeZoneInfo.Text = timeZone
            Else
                List1.Items.Add(("Unable to Get User Timezone!!"))
            End If
        End If
    End Sub

    'function to set / update user timezone
    Private Sub btnSetTimeZone_Click(sender As Object, e As EventArgs) Handles btnSetTimeZone.Click
        Dim enrollNo As Integer = 0
        Dim timeZone As String = ""

        If txtEnrollNoTimezone.Text = "" OrElse txtEnrollNoTimezone.Text = "" Then
            MessageBox.Show("Required Field: Enroll No or TimeZone!!")
        Else
            enrollNo = Convert.ToInt32(txtEnrollNoTimezone.Text)
            timeZone = txtTimeZoneInfo.Text

            If AxBioBridgeSDKv3lib1.SetUserTimezone(enrollNo, timeZone) = 0 Then
                List1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & " Timezone: " & timeZone))
            Else
                List1.Items.Add(("Unable to Set Timezone!"))
            End If
        End If
    End Sub

    'function to get the group timezone
    Private Sub btnGetGTimeZone_Click(sender As Object, e As EventArgs) Handles btnGetGTimeZone.Click
        Dim groupNo As Integer = 0
        Dim timeZone As String = ""

        If txtGroupNo.Text = "" Then
            MessageBox.Show("Required Field: Group No!!")
        Else
            groupNo = Convert.ToInt32(txtGroupNo.Text)

            If AxBioBridgeSDKv3lib1.GetGroupTimezone(groupNo, timeZone) = 0 Then
                List1.Items.Add(("Group No: " & Convert.ToString(groupNo) & " Timezone: " & timeZone))
                txtTimeZoneInfo.Text = timeZone
            Else
                List1.Items.Add(("No Record Found!!"))
            End If
        End If
    End Sub

    'function to set / update the group timezone
    Private Sub btnSetGTimeZone_Click(sender As Object, e As EventArgs) Handles btnSetGTimeZone.Click
        Dim groupNo As Integer = 0
        Dim timeZone As String = ""

        If txtGroupNo.Text = "" OrElse txtTimeZoneInfo.Text = "" Then
            MessageBox.Show("Required Field: Group No or TimeZone!!")
        Else
            groupNo = Convert.ToInt32(txtGroupNo.Text)
            timeZone = txtTimeZoneInfo.Text

            If AxBioBridgeSDKv3lib1.SetGroupTimezone(groupNo, timeZone) = 0 Then
                List1.Items.Add(("Group Timezone Set"))
            Else
                List1.Items.Add(("Unable to set Timezone!"))
            End If
        End If
    End Sub

    'function to get the timezone string based on the timezone id
    Private Sub btnGetTimeZoneNo_Click(sender As Object, e As EventArgs) Handles btnGetTimeZoneNo.Click
        Dim timeZoneId As Integer = 0
        Dim timeZoneInfo As String = ""

        If txtTimeZoneNo.Text = "" Then
            MessageBox.Show("Required Field: TimeZone No!!")
        Else
            timeZoneId = Convert.ToInt32(txtTimeZoneNo.Text)

            If AxBioBridgeSDKv3lib1.GetTimezoneInfo(timeZoneId, timeZoneInfo) = 0 Then
                List1.Items.Add(("TimeZone ID: " & Convert.ToString(timeZoneId) & " Info: " & timeZoneInfo))
                txtTimeZoneStr.Text = timeZoneInfo
            Else
                List1.Items.Add(("TimeZone Not Found!!"))
            End If
        End If
    End Sub

    'function to set / update the timezone string information
    Private Sub btnSetTimeZoneNo_Click(sender As Object, e As EventArgs) Handles btnSetTimeZoneNo.Click
        Dim timeZoneId As Integer = 0
        Dim timeZoneInfo As String = ""

        If txtTimeZoneNo.Text = "" OrElse txtTimeZoneStr.Text = "" Then
            MessageBox.Show("Required Field: TimeZone No or TimeZone Info!!")
        Else
            timeZoneId = Convert.ToInt32(txtTimeZoneNo.Text)
            timeZoneInfo = txtTimeZoneStr.Text

            If AxBioBridgeSDKv3lib1.SetTimezoneInfo(timeZoneId, timeZoneInfo) = 0 Then
                List1.Items.Add(("TimeZone Set"))
            Else
                List1.Items.Add(("Unable to Set TimeZone!!"))
            End If
        End If
    End Sub

    'function to get the unlock groups
    Private Sub btnGetUnlockG_Click(sender As Object, e As EventArgs) Handles btnGetUnlockG.Click
        Dim unlockGroup As String = ""

        If AxBioBridgeSDKv3lib1.GetUnlockGroup(unlockGroup) = 0 Then
            List1.Items.Add(("Unlock group: " & unlockGroup))
            txtUnlockGroup.Text = unlockGroup
        Else
            List1.Items.Add(("Unlock group Not Found!!"))
        End If
    End Sub

    'function to set the unlock groups
    Private Sub btnSetUnlockG_Click(sender As Object, e As EventArgs) Handles btnSetUnlockG.Click
        Dim unlockGroup As String = ""

        unlockGroup = txtUnlockGroup.Text

        If AxBioBridgeSDKv3lib1.SetUnlockGroup(unlockGroup) = 0 Then
            List1.Items.Add(("Unlock Group Set"))
        Else
            List1.Items.Add(("Unable to Set!!"))
        End If
    End Sub

    'open the specific filename
    Private Sub btnOpenFile_Click(sender As Object, e As EventArgs) Handles btnOpenFile.Click
        Dim openFileDialog1 As New OpenFileDialog()
        openFileDialog1.ShowDialog()
        txtFilename.Text = openFileDialog1.FileName
    End Sub


    'function to get the user data from a filename
    Private Sub btnGetUserFileUSB_Click(sender As Object, e As EventArgs) Handles btnGetUserFileUSB.Click
        'short Index = btnGetUserFileUSB.//GetIndex(sender);
        Dim record As Object = ""
        Dim enrollNo As Integer = 0
        Dim name_Renamed As String = ""
        Dim pwd As String = ""
        Dim priv As Integer = 0
        Dim TZgroup As Integer = 0
        Dim TZinfo As String = ""
        Dim fileName As String = ""

        If txtFilename.Text = "" Then
            MessageBox.Show("Required Field: FileName!!")
        Else
            fileName = txtFilename.Text

            If AxBioBridgeSDKv3lib1.ReadUserFile(fileName) = 0 Then
                Do
                    'read the user file into the memory buffer
                    List1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & " Name: " & name_Renamed & " Pwd: " & pwd & " Privilege: " & Convert.ToString(priv) & " TimeZone G: " & Convert.ToString(TZgroup) & " TimeZone Info: " & TZinfo))
                    txtEnrollNoUSB.Text = Convert.ToString(enrollNo)
                    txtNameUSB.Text = name_Renamed
                    txtPasswordUSB.Text = pwd
                    txtPriviledgeUSB.Text = Convert.ToString(priv)
                    txtTimeZoneGUSB.Text = Convert.ToString(TZgroup)
                    txtTimeZoneInfoUSB.Text = TZinfo
                    txtRecordSize.Text = Convert.ToString(record)
                Loop While AxBioBridgeSDKv3lib1.GetUserFileData(enrollNo, name_Renamed, pwd, priv, TZgroup, TZinfo) = 0
            Else
                List1.Items.Add(("No Record Found!!"))
            End If
        End If
    End Sub

    'function to save the user information back to the file
    Private Sub btnSaveToFile_Click(sender As Object, e As EventArgs) Handles btnSaveToFile.Click
        Dim enrollNo As Integer = 0
        Dim name_Renamed As String = ""
        Dim pwd As String = ""
        Dim priv As Integer = 0
        Dim TZgroup As Integer = 0
        Dim TZinfo As String = ""
        Dim record As Integer = 0
        Dim fileName As String = ""
        Dim sCardNo As String = ""

        If txtEnrollNoUSB.Text = "" OrElse txtNameUSB.Text = "" OrElse txtPasswordUSB.Text = "" OrElse txtPriviledgeUSB.Text = "" OrElse txtTimeZoneGUSB.Text = "" OrElse txtTimeZoneInfoUSB.Text = "" OrElse txtRecordSize.Text = "" OrElse txtFilename.Text = "" Then
            MessageBox.Show("Required Fields: Enroll No; Name; Pwd; Privilege; TZGroup; TZInfo; Record No; FileName!!")
        Else
            enrollNo = Convert.ToInt32(txtEnrollNoUSB.Text)
            name_Renamed = txtNameUSB.Text
            pwd = txtPasswordUSB.Text
            priv = Convert.ToInt32(txtPriviledgeUSB.Text)
            TZgroup = Convert.ToInt32(txtTimeZoneGUSB.Text)
            TZinfo = txtTimeZoneInfoUSB.Text
            record = Convert.ToInt32(txtRecordSize.Text)
            fileName = txtFilename.Text
            sCardNo = txtCardNo.Text

            'read the data back to the memory buffer
            If AxBioBridgeSDKv3lib1.PutUserFileDataCard(enrollNo, name_Renamed, pwd, priv, TZgroup, TZinfo, sCardNo, record) = 0 Then
                If AxBioBridgeSDKv3lib1.WriteUserFile(fileName) = 0 Then
                    List1.Items.Add(("User Info Saved to File"))
                Else
                    List1.Items.Add(("Unable to Save User Info!!"))
                End If
            End If
        End If
    End Sub

    'function to get user fingerprint template from a file
    Private Sub btnGetTemplateUSB_Click(sender As Object, e As EventArgs) Handles btnGetTemplateUSB.Click
        Dim fileName As String = ""
        Dim enrollNo As Integer = 0
        Dim fingerId As Integer = 0
        Dim template As String = ""

        If txtFilename.Text = "" Then
            MessageBox.Show("Required Field: FileName!!")
        Else
            fileName = txtFilename.Text

            'read the user template data from a filename into a memory buffer
            If AxBioBridgeSDKv3lib1.ReadTemplateFile(fileName) = 0 Then
                Do
                    List1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & " Finger Index: " & Convert.ToString(fingerId) & " Template: " & template))
                    txtEnrollNoUSB.Text = Convert.ToString(enrollNo)
                    txtFingerIndexUSB.Text = Convert.ToString(fingerId)
                    txtFingerTemplateUSB.Text = template
                Loop While AxBioBridgeSDKv3lib1.GetTemplateFileData(enrollNo, fingerId, template) = 0
            Else
                List1.Items.Add(("No Template Found!!"))
            End If
        End If
    End Sub

    'function to save back the user fingerprint template to a file name
    Private Sub btnSaveTemplateUSB_Click(sender As Object, e As EventArgs) Handles btnSaveTemplateUSB.Click
        Dim enrollNo As Integer = 0
        Dim fingerId As Integer = 0
        Dim template As String = ""
        Dim record As Integer = 0
        Dim fileName As String = ""

        If txtEnrollNoUSB.Text = "" OrElse txtFingerIndexUSB.Text = "" OrElse txtFingerTemplateUSB.Text = "" OrElse txtRecordSize.Text = "" OrElse txtFilename.Text = "" Then
            MessageBox.Show("Required Fields: Enrollment No; Finger Index; Template String; Record No; FileName!!")
        Else
            enrollNo = Convert.ToInt32(txtEnrollNoUSB.Text)
            fingerId = Convert.ToInt32(txtFingerIndexUSB.Text)
            template = txtFingerTemplateUSB.Text
            record = Convert.ToInt32(txtRecordSize.Text)
            fileName = txtFilename.Text

            'put the data back into the memory buffer
            If AxBioBridgeSDKv3lib1.PutTemplateFileData(enrollNo, fingerId, template, record) = 0 Then
                'write back the user fingerprint template data back to the file
                If AxBioBridgeSDKv3lib1.WriteTemplateFile(fileName) = 0 Then
                    List1.Items.Add(("Template Saved"))
                Else
                    List1.Items.Add(("Unable to Save Template!!"))
                End If
            End If
        End If
    End Sub

    Private Sub btnDecryptAttLog_Click(sender As Object, e As EventArgs) Handles btnDecryptAttLog.Click
        Dim val1 As String = ""
        Dim val2 As String = ""
        Dim tmp As String = ""
        Dim myForm4 As New Form4()

        Dim fLen As Integer = FileSystem.FreeFile()
        FileSystem.FileOpen(fLen, txtFilename.Text, OpenMode.Binary, OpenAccess.Read, OpenShare.[Shared], -1)

        tmp = New [String](" "c, Convert.ToInt32(FileSystem.FileLen(txtFilename.Text)))

        FileSystem.FileGet(fLen, tmp, -1, False)
        FileSystem.FileClose(fLen)

        val1 = tmp
        Dim ReadFile As String = val1

        Dim iRead As Integer = 10000
        Dim iPos As Integer = 0
        Dim FullData As [String] = ""
        Dim SubData As [String] = ""

        While val1.Length > iPos
            If (iPos + iRead) > val1.Length Then
                iRead = val1.Length - iPos
            End If

            val2 = ""
            SubData = val1.Substring(iPos, iRead)

            If AxBioBridgeSDKv3lib1.DecryptLog(SubData, val2) = 0 Then
                FullData = FullData & val2
            End If

            iPos = iPos + iRead
        End While

        myForm4.Text1.Text = FullData
        myForm4.Show()
    End Sub
#End Region

#Region "SMS & GrpVerType Demo"
    Private Sub btnGetUserVerType_Click(sender As Object, e As EventArgs) Handles btnGetUserVerType.Click
        Dim enrollNo As Integer = 0
        Dim verTypeNo As Integer = 0

        enrollNo = Convert.ToInt32(txtEnrollNo.Text)

        If AxBioBridgeSDKv3lib1.GetUserVerType(enrollNo, verTypeNo) = 0 Then
            lblStatus.Text = ("GetUserVerType Successed")
            txtVerType.Text = Convert.ToString(verTypeNo)
        Else
            lblStatus.Text = ("GetUserVerType Fail")
            txtVerType.Text = "0"
        End If
    End Sub

    Private Sub btnSetUserVerType_Click(sender As Object, e As EventArgs) Handles btnSetUserVerType.Click
        Dim enrollNo As Integer = 0
        Dim verTypeNo As Integer = 0

        enrollNo = Convert.ToInt32(txtEnrollNo.Text)
        verTypeNo = Convert.ToInt32(txtVerType.Text)

        If AxBioBridgeSDKv3lib1.SetUserVerType(enrollNo, verTypeNo) = 0 Then
            lblStatus.Text = ("SetUserVerType Successed")
        Else
            lblStatus.Text = ("SetUserVerType Fail")
        End If
    End Sub

    Private Sub btnGetSMS_Click(sender As Object, e As EventArgs) Handles btnGetSMS.Click
        Dim tag_Renamed As Integer = 0
        Dim validMinutes As Integer = 0
        Dim startTime As String = ""
        Dim content As String = ""
        Dim smsid As Integer = Convert.ToInt32(txtSMSID.Text)

        If AxBioBridgeSDKv3lib1.GetSMS(smsid, tag_Renamed, validMinutes, startTime, content) = 0 Then
            txtContent.Text = content

            If tag_Renamed = 253 Then
                optPublic.Checked = True
            Else
                optPrivate.Checked = True
            End If

            txtValidTime.Text = Convert.ToString(validMinutes)
            txtStartTime.Text = startTime
            lblStatus.Text = ("GetSMS Successed")
        Else
            lblStatus.Text = ("GetSMS Fail")
        End If
    End Sub

    Private Sub btnSetSMS_Click(sender As Object, e As EventArgs) Handles btnSetSMS.Click
        Dim smsId As Integer = 0
        Dim smsTag As Integer = 0
        Dim validMinutes As Integer = 0
        Dim startTime As String = ""
        Dim content As String = ""
        'int b = 0;

        smsId = Convert.ToInt32(txtSMSID.Text)
        content = txtContent.Text

        If (optPublic.Checked) = True Then
            smsTag = 253
        Else
            smsTag = 254
        End If

        validMinutes = Convert.ToInt32(txtValidTime.Text)
        startTime = txtStartTime.Text

        If AxBioBridgeSDKv3lib1.SetSMS(smsId, smsTag, validMinutes, startTime, content) = 0 Then
            lblStatus.Text = ("Set SMS Successed")
        Else
            lblStatus.Text = ("Set SMS Fail")
        End If
    End Sub

    Private Sub btnDeleteSMS_Click(sender As Object, e As EventArgs) Handles btnDeleteSMS.Click
        If AxBioBridgeSDKv3lib1.DeleteSMS(Convert.ToInt32(txtSMSID.Text)) = 0 Then
            lblStatus.Text = ("DeleteSMS Successed")
        Else
            lblStatus.Text = ("DeleteSMS Fail")
        End If
    End Sub

    Private Sub btnClearSMS_Click(sender As Object, e As EventArgs) Handles btnClearSMS.Click
        If AxBioBridgeSDKv3lib1.ClearSMS() = 0 Then
            lblStatus.Text = ("ClearSMS Successed")
        Else
            lblStatus.Text = ("ClearSMS Fail")
        End If
    End Sub

    Private Sub btnSetUserSMS_Click(sender As Object, e As EventArgs) Handles btnSetUserSMS.Click
        If AxBioBridgeSDKv3lib1.SetUserSMS(Convert.ToInt32(txtEnrollNoSMS.Text), Convert.ToInt32(txtSMSID.Text)) = 0 Then
            lblStatus.Text = ("SetUserSMS Successed")
        Else
            lblStatus.Text = ("SetUserSMS Fail")
        End If
    End Sub

    Private Sub btnDeleteUserSMS_Click(sender As Object, e As EventArgs) Handles btnDeleteUserSMS.Click
        If AxBioBridgeSDKv3lib1.DeleteUserSMS(Convert.ToInt32(txtEnrollNoSMS.Text), Convert.ToInt32(txtSMSID.Text)) = 0 Then
            lblStatus.Text = ("DeleteUserSMS Successed")
        Else
            lblStatus.Text = ("DeleteUserSMS Fail")
        End If
    End Sub

    Private Sub btnClearUserSMS_Click(sender As Object, e As EventArgs) Handles btnClearUserSMS.Click
        If AxBioBridgeSDKv3lib1.ClearUserSMS() = 0 Then
            lblStatus.Text = ("ClearUserSMS Successed")
        Else
            lblStatus.Text = ("ClearUserSMS Fail")
        End If
    End Sub

    Private Sub btnSSRSetUserSMS_Click(sender As Object, e As EventArgs) Handles btnSSRSetUserSMS.Click
        If AxBioBridgeSDKv3lib1.SSR_SetUserSMS(Convert.ToString(txtEnrollNoSMS.Text), Convert.ToInt32(txtSMSID.Text)) = 0 Then
            lblStatus.Text = ("SetUserSMS Successed")
        Else
            lblStatus.Text = ("SetUserSMS Fail")
        End If
    End Sub

    Private Sub btnSSRDelUserSMS_Click(sender As Object, e As EventArgs) Handles btnSSRDelUserSMS.Click
        If AxBioBridgeSDKv3lib1.SSR_DeleteUserSMS(Convert.ToString(txtEnrollNoSMS.Text), Convert.ToInt32(txtSMSID.Text)) = 0 Then
            lblStatus.Text = ("DeleteUserSMS Successed")
        Else
            lblStatus.Text = ("DeleteUserSMS Fail")
        End If
    End Sub
#End Region

#Region "Color Screen Models Functions Demo"
    Private Sub btnSSRGetAllUser_Click(sender As Object, e As EventArgs) Handles btnSSRGetAllUser.Click
        Dim enrollNo As String = ""
        Dim name_Renamed As String = ""
        Dim pwd As String = ""
        Dim priv As Integer = 0
        Dim enable As [Boolean] = False
        Dim iSize As Integer = 0

        If AxBioBridgeSDKv3lib1.ReadAllUserInfo(iSize) = 0 Then
            Do
                listBox1.Items.Add(("Enroll No: " & enrollNo & " Name: " & name_Renamed & " Pwd: " & pwd & " Enable: " & Convert.ToString(enable)))
            Loop While AxBioBridgeSDKv3lib1.SSR_GetAllUserInfo(enrollNo, name_Renamed, pwd, priv, enable) = 0
        End If
    End Sub

    Private Sub btnSSRGetGeneralLog_Click(sender As Object, e As EventArgs) Handles btnSSRGetGeneralLog.Click
        Dim enrollNo As String = ""
        Dim yr As Integer = 0
        Dim mth As Integer = 0
        Dim day_Renamed As Integer = 0
        Dim hr As Integer = 0
        Dim min As Integer = 0
        Dim sec As Integer = 0
        Dim ver As Integer = 0
        Dim io As Integer = 0
        Dim work As Integer = 0
        Dim iSize As Integer = 0

        'axBioBridgeSDKv3lib1.SetLastCount(Convert.ToInt32(txtSetLastCount.Text))

        If AxBioBridgeSDKv3lib1.ReadGeneralLog(iSize) = 0 Then
            Do
                listBox1.Items.Add(("No: " & enrollNo & " Date: " & Convert.ToString(day_Renamed) & "/" & Convert.ToString(mth) & "/" & Convert.ToString(yr) & " Time: " & Convert.ToString(hr) & ":" & Convert.ToString(min) & ":" & Convert.ToString(sec) & " Verify: " & Convert.ToString(ver) & " I/O: " & Convert.ToString(io) & " Work Code: " & Convert.ToString(work)))
            Loop While AxBioBridgeSDKv3lib1.SSR_GetGeneralLog(enrollNo, yr, mth, day_Renamed, hr, min,
             sec, ver, io, work) = 0
        End If
    End Sub

    Private Sub btnSSRGetUserInfo_Click(sender As Object, e As EventArgs) Handles btnSSRGetUserInfo.Click
        Dim Combo1 As Object
        Dim enrollNo As String = ""
        Dim name_Renamed As String = ""
        Dim pwd As String = ""
        Dim level As Integer = 0
        Dim cardNo As String = ""
        Dim status As [Boolean] = False

        If edtEnrollNo.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No!!")
        Else
            enrollNo = edtEnrollNo.Text
            If AxBioBridgeSDKv3lib1.SSR_GetUserInfo(enrollNo, name_Renamed, pwd, level, status) = 0 Then
                edtName.Text = name_Renamed
                edtPwd.Text = pwd
                edtPri.Text = Convert.ToString(level)

                If status Then
                    edtValid.Text = "Y"
                Else
                    edtValid.Text = "N"
                End If

                Combo1 = status
                'cardNo = axBioBridgeSDKv3lib1.CardNo;
                AxBioBridgeSDKv3lib1.GetCardNo(cardNo)
                edtCardNo.Text = cardNo

                listBox1.Items.Add(("Enroll No: " & enrollNo & " Name: " & name_Renamed & " Pwd: " & pwd & " Privilege: " & Convert.ToString(level) & " Enabled: " & Convert.ToString(status) & " CardNo: " & Convert.ToString(cardNo)))
            Else
                listBox1.Items.Add(("No Record Found!!"))
            End If
        End If
    End Sub

    Private Sub btnSSRSetUserInfo_Click(sender As Object, e As EventArgs) Handles btnSSRSetUserInfo.Click
        Dim enrollNo As String = ""
        Dim name_Renamed As String = ""
        Dim pwd As String = ""
        Dim priv As Integer = 0
        Dim cardNo As String = ""
        Dim status As [Boolean] = False

        If edtEnrollNo.Text = "" OrElse edtValid.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No; Privilege!!")
        Else
            enrollNo = edtEnrollNo.Text
            name_Renamed = edtName.Text
            pwd = edtPwd.Text
            priv = Convert.ToInt32(edtPri.Text)
            'axBioBridgeSDKv3lib1.CardNo = cardNo;
            cardNo = edtCardNo.Text
            AxBioBridgeSDKv3lib1.SetCardNo(cardNo)

            If edtValid.Text = "Y" Then
                status = True
            Else
                status = False
            End If

            If AxBioBridgeSDKv3lib1.SSR_SetUserInfo(enrollNo, name_Renamed, pwd, priv, status) = 0 Then
                listBox1.Items.Add(("User Info Set"))
                listBox1.Items.Add(("Enroll No: " & enrollNo & " Name: " & name_Renamed & " Pwd: " & pwd & " Privilege: " & Convert.ToString(priv) & " Enabled: " & Convert.ToString(status) & " CardNo: " & cardNo))
            Else
                listBox1.Items.Add(("No Record Found!!"))
            End If
        End If
    End Sub

    Private Sub btnSSRDelUserInfo_Click(sender As Object, e As EventArgs) Handles btnSSRDelUserInfo.Click
        Dim enrollNo As String = ""

        If edtEnrollNo.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No!!")
        Else
            enrollNo = edtEnrollNo.Text

            If AxBioBridgeSDKv3lib1.SSR_DeleteUserData(enrollNo) = 0 Then
                listBox1.Items.Add(("User Information Removed"))
            Else
                listBox1.Items.Add(("Unable to Remove User!!"))
            End If
        End If
    End Sub

    Private Sub btnGetUserTpl_Click(sender As Object, e As EventArgs) Handles btnGetUserTpl.Click
        Dim enrollNo As String = ""
        Dim fingerId As Integer = 0
        Dim template As String = ""

        If edtEnrollNo.Text = "" OrElse edtFinger.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No; Finger Index No!")
        Else
            enrollNo = edtEnrollNo.Text
            fingerId = Convert.ToInt32(edtFinger.Text)

            If AxBioBridgeSDKv3lib1.SSR_GetUserTemplate(enrollNo, fingerId, template) = 0 Then
                listBox1.Items.Add(("Enroll No: " & enrollNo & " Index Finger: " & Convert.ToString(fingerId) & " Template: " & template))
                mmTpl.Text = template
            Else
                listBox1.Items.Add(("No User Record Found!!"))
            End If
        End If
    End Sub

    Private Sub btnSetUserTpl_Click(sender As Object, e As EventArgs) Handles btnSetUserTpl.Click
        Dim enrollNo As String = ""
        Dim fingerId As Integer = 0
        Dim template As String = ""

        If edtEnrollNo.Text = "" OrElse edtFinger.Text = "" OrElse mmTpl.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No; Finger Index No; Template String!")
        Else
            enrollNo = edtEnrollNo.Text
            fingerId = Convert.ToInt32(edtFinger.Text)
            template = mmTpl.Text

            If AxBioBridgeSDKv3lib1.SSR_SetUserTemplate(enrollNo, fingerId, template) = 0 Then
                listBox1.Items.Add(("User fingerprint template SET"))
            Else
                listBox1.Items.Add(("Unable to Set Fingerprint Template!"))
            End If
        End If
    End Sub

    Private Sub btnDelUserTpl_Click(sender As Object, e As EventArgs) Handles btnDelUserTpl.Click
        Dim fingerId As Integer = 0
        Dim enrollNo As String = ""

        If edtEnrollNo.Text = "" OrElse edtFinger.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No; Finger Index No!!")
        Else
            enrollNo = edtEnrollNo.Text
            fingerId = Convert.ToInt32(edtFinger.Text)

            If AxBioBridgeSDKv3lib1.SSR_DeleteUserTemplate(enrollNo, fingerId) = 0 Then
                listBox1.Items.Add(("Fingerprint Template Removed"))
            Else
                listBox1.Items.Add(("Unable to Remove!!"))
            End If
        End If
    End Sub

    Private Sub btnGetUserFace_Click(sender As Object, e As EventArgs) Handles btnGetUserFace.Click
        Dim faceTpl As String = ""
        mmTpl.Text = ""

        If AxBioBridgeSDKv3lib1.GetUserFace(edtEnrollNo.Text, faceTpl) = 0 Then
            mmTpl.Text = faceTpl
            listBox1.Items.Add(("GetUserFace OK"))
        Else
            listBox1.Items.Add(("GetUserFace Error!!"))
        End If
    End Sub

    Private Sub btnSetUserFace_Click(sender As Object, e As EventArgs) Handles btnSetUserFace.Click
        Dim faceTpl As String = mmTpl.Text

        If AxBioBridgeSDKv3lib1.SetUserFace(edtEnrollNo.Text, faceTpl) = 0 Then
            listBox1.Items.Add(("SetUserFace OK"))
        Else
            listBox1.Items.Add(("SetUserFace Error!!"))
        End If
    End Sub

    Private Sub btnDelUserFace_Click(sender As Object, e As EventArgs) Handles btnDelUserFace.Click
        If AxBioBridgeSDKv3lib1.DeleteUserFace(edtEnrollNo.Text) = 0 Then
            listBox1.Items.Add(("DeleteUserFace OK"))
        Else
            listBox1.Items.Add(("DeleteUserFace Error!!"))
        End If
    End Sub

    Private Sub btnGetWC_Click(sender As Object, e As EventArgs) Handles btnGetWC.Click
        Dim WCID As Integer = 0
        Dim workCode As String = ""

        If edtWCID.Text = "" Then
            MessageBox.Show("Required Field: WorkCode ID!")
        Else
            WCID = Convert.ToInt32(edtWCID.Text)

            If AxBioBridgeSDKv3lib1.SSR_GetWorkCode(WCID, workCode) = 0 Then
                edtWC.Text = workCode
                listBox1.Items.Add(("WorkCode ID: " & Convert.ToString(WCID) & " WorkCode: " & workCode))
            Else
                listBox1.Items.Add(("No WorkCode Record Found!!"))
                edtWC.Text = ""
            End If
        End If
    End Sub

    Private Sub btnSetWC_Click(sender As Object, e As EventArgs) Handles btnSetWC.Click
        Dim WCID As Integer = 0
        Dim workCode As String = ""

        If edtWCID.Text = "" OrElse edtWC.Text = "" Then
            MessageBox.Show("Required Field: WorkCode ID, WorkCode!")
        Else
            WCID = Convert.ToInt32(edtWCID.Text)
            workCode = edtWC.Text

            If AxBioBridgeSDKv3lib1.SSR_SetWorkCode(WCID, workCode) = 0 Then
                listBox1.Items.Add(("WorkCode Set WorkCode ID: " & Convert.ToString(WCID) & " WorkCode:" & workCode))
            Else
                listBox1.Items.Add(("Unable to Set WorkCode!"))
            End If
        End If
    End Sub

    Private Sub btnDeleteWC_Click(sender As Object, e As EventArgs) Handles btnDeleteWC.Click
        Dim WCID As Integer = 0

        If edtWCID.Text = "" Then
            MessageBox.Show("Required Field: WorkCode ID!")
        Else
            WCID = Convert.ToInt32(edtWCID.Text)

            If AxBioBridgeSDKv3lib1.SSR_DeleteWorkCode(WCID) = 0 Then
                listBox1.Items.Add(("Deleted WorkCode ID: " & Convert.ToString(WCID)))
            Else
                listBox1.Items.Add(("Unable to Delete WorkCode!!"))
            End If
        End If
    End Sub

    Private Sub btnClearWC_Click(sender As Object, e As EventArgs) Handles btnClearWC.Click
        If AxBioBridgeSDKv3lib1.SSR_ClearWorkCode() = 0 Then
            listBox1.Items.Add(("All WorkCode Cleared"))
        Else
            listBox1.Items.Add(("Unable to Clear WorkCode!!"))
        End If
    End Sub

    Private Sub btnGetUnlockGroup_Click(sender As Object, e As EventArgs) Handles btnGetUnlockGroup.Click
        Dim combNo As Integer = 0
        Dim G1 As Integer = 0
        Dim G2 As Integer = 0
        Dim G3 As Integer = 0
        Dim G4 As Integer = 0
        Dim G5 As Integer = 0

        If edtComNo.Text = "" Then
            MessageBox.Show("Required Field: Comb No!")
        Else
            combNo = Convert.ToInt32(edtComNo.Text)

            If AxBioBridgeSDKv3lib1.SSR_GetUnlockGroup(combNo, G1, G2, G3, G4, G5) = 0 Then
                List1.Items.Add(("GetUnlockGroup   CombNo:" & Convert.ToString(combNo) & " Group1: " & Convert.ToString(G1) & "  Group2: " & Convert.ToString(G2) & "  Group3: " & Convert.ToString(G3) & "  Group4: " & Convert.ToString(G4) & "  Group5: " & Convert.ToString(G5)))
                edtG1.Text = Convert.ToString(G1)
                edtG2.Text = Convert.ToString(G2)
                edtG3.Text = Convert.ToString(G3)
                edtG4.Text = Convert.ToString(G4)
                edtG5.Text = Convert.ToString(G5)
            Else
                List1.Items.Add(("No Record Found!!"))
                edtG1.Text = "0"
                edtG2.Text = "0"
                edtG3.Text = "0"
                edtG4.Text = "0"
                edtG5.Text = "0"
            End If
        End If
    End Sub

    Private Sub btnSetUnlockGroup_Click(sender As Object, e As EventArgs) Handles btnSetUnlockGroup.Click
        Dim combNo As Integer = 0
        Dim G1 As Integer = 0
        Dim G2 As Integer = 0
        Dim G3 As Integer = 0
        Dim G4 As Integer = 0
        Dim G5 As Integer = 0

        If edtComNo.Text = "" OrElse edtG1.Text = "" OrElse edtG2.Text = "" OrElse edtG3.Text = "" OrElse edtG4.Text = "" OrElse edtG5.Text = "" Then
            MessageBox.Show("Required Field: Comb No, G1, G2, G3, G4, G5!")
        Else
            combNo = Convert.ToInt32(edtComNo.Text)
            G1 = Convert.ToInt32(edtG1.Text)
            G2 = Convert.ToInt32(edtG2.Text)
            G3 = Convert.ToInt32(edtG3.Text)
            G4 = Convert.ToInt32(edtG4.Text)
            G5 = Convert.ToInt32(edtG5.Text)

            If AxBioBridgeSDKv3lib1.SSR_SetUnLockGroup(combNo, G1, G2, G3, G4, G5) = 0 Then
                listBox1.Items.Add(("SetUnlockGroup   CombNo:" & Convert.ToString(combNo) & " Group1: " & Convert.ToString(G1) & "  Group2: " & Convert.ToString(G2) & "  Group3: " & Convert.ToString(G3) & "  Group4: " & Convert.ToString(G4) & "  Group5: " & Convert.ToString(G5)))
            Else
                listBox1.Items.Add(("SetUnlockGroup Failed!!"))
            End If
        End If
    End Sub

    Private Sub btnGetGroupTZ_Click(sender As Object, e As EventArgs) Handles btnGetGroupTZ.Click
        Dim TZGID As Integer = 0
        Dim Hol As Integer = 0
        Dim VerMode As Integer = 0
        Dim TZ1 As Integer = 0
        Dim TZ2 As Integer = 0
        Dim TZ3 As Integer = 0

        If edtTZGID.Text = "" Then
            MessageBox.Show("Required Field: TimeZoneGroup!!")
        Else
            TZGID = Convert.ToInt32(edtTZGID.Text)

            If AxBioBridgeSDKv3lib1.SSR_GetGroupTimezone(TZGID, TZ1, TZ2, TZ3, Hol, VerMode) = 0 Then
                listBox1.Items.Add(("GetGroupTimeZone :" & Convert.ToString(TZGID) & " Holiday:" & Convert.ToString(Hol) & "  VerMode:" & Convert.ToString(VerMode) & "   TZ1:" & Convert.ToString(TZ1) & " TZ2:" & Convert.ToString(TZ2) & " TZ3:" & Convert.ToString(TZ3)))
                edtHol.Text = Convert.ToString(Hol)
                edtVerMode.Text = Convert.ToString(VerMode)
                edtTZ1.Text = Convert.ToString(TZ1)
                edtTZ2.Text = Convert.ToString(TZ2)
                edtTZ3.Text = Convert.ToString(TZ3)
            Else
                listBox1.Items.Add(("No Record Found!!"))
                edtHol.Text = ""
                edtVerMode.Text = ""
                edtTZ1.Text = ""
                edtTZ2.Text = ""
                edtTZ3.Text = ""
            End If
        End If
    End Sub

    Private Sub btnSetGroupTZ_Click(sender As Object, e As EventArgs) Handles btnSetGroupTZ.Click
        Dim TZGID As Integer = 0
        Dim Hol As Integer = 0
        Dim VerMode As Integer = 0
        Dim TZ1 As Integer = 0
        Dim TZ2 As Integer = 0
        Dim TZ3 As Integer = 0

        If edtTZGID.Text = "" OrElse edtHol.Text = "" OrElse edtVerMode.Text = "" OrElse edtTZ1.Text = "" OrElse edtTZ2.Text = "" OrElse edtTZ3.Text = "" Then
            MessageBox.Show("Required Field: TimeZoneGroup, Holiday, VerMode, TZ1, TZ2, TZ3!!")
        Else
            TZGID = Convert.ToInt32(edtTZGID.Text)
            Hol = Convert.ToInt32(edtHol.Text)
            VerMode = Convert.ToInt32(edtVerMode.Text)
            TZ1 = Convert.ToInt32(edtTZ1.Text)
            TZ2 = Convert.ToInt32(edtTZ2.Text)
            TZ3 = Convert.ToInt32(edtTZ3.Text)

            If AxBioBridgeSDKv3lib1.SSR_SetGroupTZ(TZGID, TZ1, TZ2, TZ3, Hol, VerMode) = 0 Then
                listBox1.Items.Add(("SetGroupTimeZone :" & Convert.ToString(TZGID) & " Holiday:" & Convert.ToString(Hol) & "  VerMode:" & Convert.ToString(VerMode) & "   TZ1:" & Convert.ToString(TZ1) & " TZ2:" & Convert.ToString(TZ2) & " TZ3:" & Convert.ToString(TZ3)))
            Else
                listBox1.Items.Add(("SetGroupTimeZone Failed!!"))
            End If
        End If
    End Sub

    Private Sub btnGetHoliday_Click(sender As Object, e As EventArgs) Handles btnGetHoliday.Click
        Dim HolID As Integer = 0
        Dim TZID As Integer = 0
        Dim BM As Integer = 0
        Dim BD As Integer = 0
        Dim EM As Integer = 0
        Dim ED As Integer = 0

        If edtHolID.Text = "" Then
            MessageBox.Show("Required Field: Holiday ID!")
        Else
            HolID = Convert.ToInt32(edtHolID.Text)

            If AxBioBridgeSDKv3lib1.SSR_GetHoliday(HolID, BM, BD, EM, ED, TZID) = 0 Then
                listBox1.Items.Add(("GetHoliday :" & Convert.ToString(HolID) & " TZGroup:" & Convert.ToString(TZID) & "   Begin Month:" & Convert.ToString(BM) & " Begin Day:" & Convert.ToString(BD) & "   End Month:" & Convert.ToString(EM) & "   End Day:" & Convert.ToString(ED)))
                edtTZID.Text = Convert.ToString(TZID)
                edtBM.Text = Convert.ToString(BM)
                edtBD.Text = Convert.ToString(BD)
                edtEM.Text = Convert.ToString(EM)
                edtED.Text = Convert.ToString(ED)
            Else
                listBox1.Items.Add(("No Record Found!!"))
                edtTZID.Text = ""
                edtBM.Text = ""
                edtBD.Text = ""
                edtEM.Text = ""
                edtED.Text = ""
            End If
        End If
    End Sub

    Private Sub btnSetHoliday_Click(sender As Object, e As EventArgs) Handles btnSetHoliday.Click
        Dim HolID As Integer = 0
        Dim TZID As Integer = 0
        Dim BM As Integer = 0
        Dim BD As Integer = 0
        Dim EM As Integer = 0
        Dim ED As Integer = 0

        If edtHolID.Text = "" OrElse edtTZID.Text = "" OrElse edtBM.Text = "" OrElse edtBD.Text = "" OrElse edtEM.Text = "" OrElse edtED.Text = "" Then
            MessageBox.Show("Required Field: Holiday ID, TimezoneGroup, Begin Month, Begin Day, End Month, End Day!")
        Else
            HolID = Convert.ToInt32(edtHolID.Text)
            TZID = Convert.ToInt32(edtTZID.Text)
            BM = Convert.ToInt32(edtBM.Text)
            BD = Convert.ToInt32(edtBD.Text)
            EM = Convert.ToInt32(edtEM.Text)
            ED = Convert.ToInt32(edtED.Text)

            If AxBioBridgeSDKv3lib1.SSR_SetHoliday(HolID, BM, BD, EM, ED, TZID) = 0 Then
                listBox1.Items.Add(("SetHoliday :" & Convert.ToString(HolID) & " TZGroup:" & Convert.ToString(TZID) & "   Begin Month:" & Convert.ToString(BM) & " Begin Day:" & Convert.ToString(BD) & "   End Month:" & Convert.ToString(EM) & "   End Day:" & Convert.ToString(ED)))
            Else
                listBox1.Items.Add(("SetHoliday Failed!!"))
            End If
        End If
    End Sub

    Private Sub btnFile_Click(sender As Object, e As EventArgs) Handles btnFile.Click
        Dim openFileDialog1 As New OpenFileDialog()
        openFileDialog1.ShowDialog()
        edtFile.Text = openFileDialog1.FileName
    End Sub

    Private Sub btnReadUserFile_Click(sender As Object, e As EventArgs) Handles btnReadUserFile.Click
        Dim enrollNo As Integer = 0
        Dim name_Renamed As String = ""
        Dim pwd As String = ""
        Dim TZ As String = ""
        Dim pri As Integer = 0
        Dim cardNo As String = ""
        Dim TZG As Integer = 0

        If edtFile.Text = "" Then
            MessageBox.Show("Required Field: File!")
        Else
            If AxBioBridgeSDKv3lib1.SSR_ReadUserFile(edtFile.Text) = 0 Then
                Do
                    listBox1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & " Name: " & name_Renamed & " Pwd: " & pwd & " Privilege: " & Convert.ToString(pri) & " TimeZone G: " & Convert.ToString(TZG) & " TimeZone Info: " & TZ & "   CardNo:" & Convert.ToString(cardNo)))
                Loop While AxBioBridgeSDKv3lib1.SSR_GetUserFileDataCard(enrollNo, name_Renamed, pwd, pri, TZG, TZ,
                 cardNo) = 0
            Else
                listBox1.Items.Add(("No Record Found!!"))
            End If
        End If
    End Sub

    Private Sub btnWriteUserFile_Click(sender As Object, e As EventArgs) Handles btnWriteUserFile.Click
        Dim CardN As String = ""

        Dim enrollNo As Integer = 0
        Dim name_Renamed As String = ""
        Dim pwd As String = ""
        Dim pri As Integer = 0
        Dim TZG As Integer = 0
        Dim TZ As String = ""
        Dim cardNo As String = ""

        If edtEnrollNoU.Text = "" OrElse edtNameU.Text = "" OrElse edtPwdU.Text = "" OrElse edtPriU.Text = "" OrElse edtTZU.Text = "" OrElse edtTZGU.Text = "" OrElse edtCardNoU.Text = "" OrElse edtFile.Text = "" Then
            MessageBox.Show("Required Fields: Enroll No, Name, Pwd, Privilege, TZGroup, TZInfo, CardNo, File!")
        Else
            enrollNo = Convert.ToInt32(edtEnrollNoU.Text)
            name_Renamed = edtNameU.Text
            pwd = edtPwdU.Text
            pri = Convert.ToInt32(edtPriU.Text)
            TZG = Convert.ToInt32(edtTZGU.Text)
            TZ = edtTZU.Text
            CardN = edtCardNoU.Text

            'read the data back to the memory buffer
            If AxBioBridgeSDKv3lib1.SSR_PutUserFileDataCard(enrollNo, name_Renamed, pwd, pri, TZG, TZ,
             cardNo, 1) = 0 Then
                'write back and save the data into the file
                If AxBioBridgeSDKv3lib1.SSR_WriteUserFile(edtFile.Text) = 0 Then
                    listBox1.Items.Add(("User Info Saved to File"))
                Else
                    listBox1.Items.Add(("Unable to Save User Info!!"))
                End If
            End If
        End If
    End Sub

    Private Sub btnGetTemplateFileData_Click(sender As Object, e As EventArgs) Handles btnGetTemplateFileData.Click
        Dim enrollNo As Integer = 0
        Dim fingerId As Integer = 0
        Dim template As String = ""

        If edtFile.Text = "" Then
            MessageBox.Show("Required Field: FileName!")
        Else
            'read the user template data from a filename into a memory buffer
            If AxBioBridgeSDKv3lib1.ReadTemplateFile(edtFile.Text) = 0 Then
                'get the user template from the memory buffer
                Do
                    listBox1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & " Finger Index: " & Convert.ToString(fingerId) & " Template: " & template))
                Loop While AxBioBridgeSDKv3lib1.GetTemplateFileData(enrollNo, fingerId, template) = 0
            Else
                listBox1.Items.Add(("No Template Found!!"))
            End If
        End If
    End Sub

    Private Sub btnSetTemplateFileData_Click(sender As Object, e As EventArgs) Handles btnSetTemplateFileData.Click
        Dim enrollNo As Integer = 0
        Dim fingerId As Integer = 0
        Dim template As String = ""

        If edtFile.Text = "" OrElse edtEnrollNoT.Text = "" OrElse edtFingerT.Text = "" OrElse mmTplT.Text = "" Then
            MessageBox.Show("Required Fields: Enrollment No; Finger Index; Template String; FileName!")
        Else
            enrollNo = Convert.ToInt32(edtEnrollNoT.Text)
            fingerId = Convert.ToInt32(edtFingerT.Text)
            template = mmTplT.Text

            'put the data back into the memory buffer
            If AxBioBridgeSDKv3lib1.PutTemplateFileData(enrollNo, fingerId, template, 1) = 0 Then
                If AxBioBridgeSDKv3lib1.WriteTemplateFile(edtFile.Text) = 0 Then
                    listBox1.Items.Add(("Template Saved"))
                Else
                    listBox1.Items.Add(("Unable to Save Template!!"))
                End If
            End If
        End If
    End Sub

    Private Sub GetFP10_Click(sender As Object, e As EventArgs) Handles GetFP10.Click
        Dim enrollNo As Integer = 0
        Dim fingerId As Integer = 0
        Dim template As String = ""

        If edtFile.Text = "" Then
            MessageBox.Show("Required Field: FileName!")
        Else
            'read the user template data from a filename into a memory buffer
            If AxBioBridgeSDKv3lib1.ReadFinger10File(edtFile.Text) = 0 Then
                Do
                    listBox1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & " Finger Index: " & Convert.ToString(fingerId) & " Template: " & template))
                Loop While AxBioBridgeSDKv3lib1.GetFinger10FileData(enrollNo, fingerId, template) = 0
            Else
                listBox1.Items.Add(("No Template Found!!"))
            End If
        End If
    End Sub

    Private Sub btnSetFP10_Click(sender As Object, e As EventArgs) Handles btnSetFP10.Click
        Dim enrollNo As Integer = 0
        Dim fingerId As Integer = 0
        Dim template As String = ""

        If edtFile.Text = "" OrElse edtEnrollNoT.Text = "" OrElse edtFingerT.Text = "" OrElse mmTplT.Text = "" Then
            MessageBox.Show("Required Field: Enrollment No; Finger Index; Template String; FileName!")
        Else
            enrollNo = Convert.ToInt32(edtEnrollNoT.Text)
            fingerId = Convert.ToInt32(edtFingerT.Text)
            template = mmTplT.Text

            'put the data back into the memory buffer
            If AxBioBridgeSDKv3lib1.PutFinger10FileData(enrollNo, fingerId, template, 1) = 0 Then
                If AxBioBridgeSDKv3lib1.WriteFinger10File(edtFile.Text) = 0 Then
                    listBox1.Items.Add(("Template Saved"))
                Else
                    listBox1.Items.Add(("Unable to Save Template!!"))
                End If
            End If
        End If
    End Sub

    Private Sub btnGetFaceData_Click(sender As Object, e As EventArgs) Handles btnGetFaceData.Click
        Dim enrollNo As Integer = 0
        Dim template As String = ""

        If edtFile.Text = "" Then
            MessageBox.Show("Required Field: FileName!")
        Else
            'read the user face template data from a filename into a memory buffer
            If AxBioBridgeSDKv3lib1.ReadFaceFile(edtFile.Text) = 0 Then
                'get the user face template from the memory buffer
                Do
                    listBox1.Items.Add(("Enroll No: " & Convert.ToString(enrollNo) & " Template: " & template))
                Loop While AxBioBridgeSDKv3lib1.GetFaceFileData(enrollNo, template) = 0
            Else
                listBox1.Items.Add(("No Template Found!!"))
            End If
        End If
    End Sub

    Private Sub btnSetFaceData_Click(sender As Object, e As EventArgs) Handles btnSetFaceData.Click
        Dim enrollNo As Integer = 0
        Dim template As String = ""

        If edtFile.Text = "" OrElse edtEnrollNoT.Text = "" OrElse mmTplT.Text = "" Then
            MessageBox.Show("Required Fields: Enrollment No; Template String; FileName!")
        Else
            enrollNo = Convert.ToInt32(edtEnrollNoT.Text)
            template = mmTplT.Text

            'put the data back into the memory buffer
            If AxBioBridgeSDKv3lib1.PutFaceFileData(enrollNo, template, 1) = 0 Then
                If AxBioBridgeSDKv3lib1.WriteFaceFile(edtFile.Text) = 0 Then
                    listBox1.Items.Add(("Template Saved"))
                Else
                    listBox1.Items.Add(("Unable to Save Template!!"))
                End If
            End If
        End If
    End Sub


#End Region

#Region "MULTIMEDIA DEMO"
    Private Sub btnUploadPicture_Click(sender As Object, e As EventArgs) Handles btnUploadPicture.Click
        If AxBioBridgeSDKv3lib1.UploadPicture(edtPicture.Text) = 0 Then
            listBox2.Items.Add(("Upload Photo Success"))
        Else
            listBox2.Items.Add(("Upload Photo Fail!!"))
        End If
    End Sub

    Private Sub btnOpenPicture_Click(sender As Object, e As EventArgs) Handles btnOpenPicture.Click
        Dim openFileDialog1 As New OpenFileDialog()
        openFileDialog1.ShowDialog()
        edtPicture.Text = openFileDialog1.FileName
    End Sub

    Private Sub btnUploadPhoto_Click(sender As Object, e As EventArgs) Handles btnUploadPhoto.Click
        If AxBioBridgeSDKv3lib1.UploadUserPhoto(edtPhoto.Text) = 0 Then
            listBox2.Items.Add(("Upload Photo Success"))
        Else
            listBox2.Items.Add(("Upload Photo Fail!!"))
        End If
    End Sub

    Private Sub btnOpenPhoto_Click(sender As Object, e As EventArgs) Handles btnOpenPhoto.Click
        Dim openFileDialog1 As New OpenFileDialog()
        openFileDialog1.ShowDialog()
        edtPhoto.Text = openFileDialog1.FileName
    End Sub

    Private Sub btnDelPicture_Click(sender As Object, e As EventArgs) Handles btnDelPicture.Click
        If AxBioBridgeSDKv3lib1.DeletePicture(edtDelPicture.Text) = 0 Then
            listBox2.Items.Add(("Delete Picture Success"))
        Else
            listBox2.Items.Add(("Delete Picture Fail!!"))
        End If
    End Sub

    Private Sub btnDelPhoto_Click(sender As Object, e As EventArgs) Handles btnDelPhoto.Click
        If AxBioBridgeSDKv3lib1.DeleteUserPhoto(edtDelPhoto.Text) = 0 Then
            listBox2.Items.Add(("Delete Photo Success"))
        Else
            listBox2.Items.Add(("Delete Photo Fail!!"))
        End If
    End Sub

    ' application must run as administrator
    Private Sub btnDownloadPhoto_Click(sender As Object, e As EventArgs) Handles btnDownloadPhoto.Click
        If AxBioBridgeSDKv3lib1.DownloadUserPhoto(edtDownloadPhoto.Text, edtPhotoPath.Text) = 0 Then
            listBox2.Items.Add(("Download Photo Success"))
        Else
            listBox2.Items.Add(("Download Photo Fail!!"))
        End If
    End Sub

    ' application must run as administrator
    Private Sub btnDownloadPicture_Click(sender As Object, e As EventArgs) Handles btnDownloadPicture.Click
        If AxBioBridgeSDKv3lib1.DownloadPicture(edtDownloadPicture.Text, edtPicPath.Text) = 0 Then
            listBox2.Items.Add(("Download Picture Success"))
        Else
            listBox2.Items.Add(("Download Picture Fail!!"))
        End If
    End Sub

    Private Sub btnGetSuccess_Click(sender As Object, e As EventArgs) Handles btnGetSuccess.Click
        Dim filePath As String = "C:\"
        Dim fileName As String = ""
        Dim filep As String = ""

        If AxBioBridgeSDKv3lib1.GetSuccessPhotos(filePath, filep) = 0 Then
            Dim length As Integer = 0
            Dim start As Integer = 1
            Dim endc As Integer = (filep.IndexOf("&") + start)
            length = endc - start
            Dim newstart As Integer = 0

            While endc > 0
                fileName = filep.Substring(newstart, length)
                listBox2.Items.Add(fileName)
                start = endc + 1
                endc = (filep.IndexOf("&") - start)
                length = endc - start
            End While

            MessageBox.Show("Download Success Picture Success")
        Else
            MessageBox.Show("Download Success Picture Failed")
        End If
    End Sub

    Private Sub btnGetFail_Click(sender As Object, e As EventArgs) Handles btnGetFail.Click
        Dim filePath As String = "C:\"
        Dim fileName As String = ""
        Dim filep As String = ""

        If AxBioBridgeSDKv3lib1.GetFailPhotos(filePath, filep) = 0 Then
            Dim length As Integer = 0
            Dim start As Integer = 1
            Dim endc As Integer = (filep.IndexOf("&") + start)
            length = endc - start
            Dim newstart As Integer = 0

            While endc > 0
                fileName = filep.Substring(newstart, length)
                listBox2.Items.Add(fileName)
                start = endc + 1
                endc = (filep.IndexOf("&") - start)
                length = endc - start
            End While

            MessageBox.Show("Download Success Picture Success")
        Else
            MessageBox.Show("Download Success Picture Failed")
        End If
    End Sub
#End Region

#Region "Add On"
    Private Sub btnPowerOn_Click(sender As Object, e As EventArgs) Handles btnPowerOn.Click
        Dim iHour As Integer = Convert.ToInt32(txtPowerHour.Text.Trim())
        Dim iMin As Integer = Convert.ToInt32(txtPowerMinute.Text.Trim())

        If AxBioBridgeSDKv3lib1.SetPowerOn(iHour, iMin) = 0 Then
            listBox3.Items.Add(("Set Power On time Success"))
        Else
            listBox3.Items.Add(("Set Power On time Fail"))
        End If

    End Sub

    Private Sub btnPowerOff_Click(sender As Object, e As EventArgs) Handles btnPowerOff.Click
        Dim iHour As Integer = Convert.ToInt32(txtPowerHour.Text.Trim())
        Dim iMin As Integer = Convert.ToInt32(txtPowerMinute.Text.Trim())

        If AxBioBridgeSDKv3lib1.SetPowerOff(iHour, iMin) = 0 Then
            listBox3.Items.Add(("Set Power Off time Success"))
        Else
            listBox3.Items.Add(("Set Power Off time Fail"))
        End If



    End Sub

    Private Sub btnH2i_TurnAlarmOff_Click(sender As Object, e As EventArgs) Handles btnH2i_TurnAlarmOff.Click
        If AxBioBridgeSDKv3lib1.TurnOffAlarm() = 0 Then
            listBox3.Items.Add(("Turn off alarm Success"))
        Else
            listBox3.Items.Add(("Turn off alarm Fail"))
        End If
    End Sub

    Private Sub btnH2iAdminCard_Get_Click(sender As Object, e As EventArgs) Handles btnH2iAdminCard_Get.Click
        Dim admincard As Integer = 0
        If AxBioBridgeSDKv3lib1.GetAdminCardNumber(admincard) = 0 Then
            txtH2iAdminCard.Text = admincard.ToString()
            listBox3.Items.Add(("Administrator Card Number = " & admincard))
        Else
            listBox3.Items.Add(("Get Administrator Card Number Fail"))
        End If

    End Sub

    Private Sub btnH2iAdminCard_Set_Click(sender As Object, e As EventArgs) Handles btnH2iAdminCard_Set.Click
        Dim admincard As Integer = Convert.ToInt32(txtH2iAdminCard.Text.Trim())
        If AxBioBridgeSDKv3lib1.SetAdminCardNumber(admincard) = 0 Then
            listBox3.Items.Add(("Set Administrator Card Number success "))
        Else
            listBox3.Items.Add(("Set Administrator Card Number Fail"))
        End If
    End Sub

    Private Sub btnSetAntipassback_Click(sender As Object, e As EventArgs) Handles btnSetAntipassback.Click
        If AxBioBridgeSDKv3lib1.SetAntipassback(txtAntipassback.Text.Trim()) = 0 Then
            listBox3.Items.Add(("Set Antipassback Success"))
        Else
            listBox3.Items.Add(("Set Antipassback Fail"))
        End If
    End Sub

    Private Sub btnGetAntipassback_Click(sender As Object, e As EventArgs) Handles btnGetAntipassback.Click
        Dim antipass As String = String.Empty
        If AxBioBridgeSDKv3lib1.GetAntipassback(antipass) = 0 Then
            listBox3.Items.Add(("Antipassback = " & antipass))
        Else
            listBox3.Items.Add(("Set Antipassback Fail"))
        End If

        txtAntipassback.Text = antipass
    End Sub

    Private Sub btnClearErrorCard_Click(sender As Object, e As EventArgs) Handles btnClearErrorCard.Click
        If AxBioBridgeSDKv3lib1.ClearErrorCard() = 0 Then
            listBox3.Items.Add(("Clear error card number success"))
        Else
            listBox3.Items.Add(("Clear error card number Fail"))
        End If
    End Sub

    Private Sub btnGetErrorCard_Click(sender As Object, e As EventArgs) Handles btnGetErrorCard.Click
        If AxBioBridgeSDKv3lib1.ReadErrorCard() = 0 Then
            Dim card As Integer = 0
            Dim str As String = String.Empty
            While AxBioBridgeSDKv3lib1.GetErrorCardData(card, str) = 0
                listBox3.Items.Add(("Error Card Number : CardNum.=" & card.ToString() & " ,DateTime=" & str))
            End While
        Else
            listBox3.Items.Add(("Get error card number Fail"))
        End If
    End Sub

    Private Sub btnBeginStart_Click(sender As Object, e As EventArgs) Handles btnBeginStart.Click
        If txtBeginEnroll.Text.Trim() = "" Then
            listBox3.Items.Add(("Enroll No cannot be empty!!!"))
            Return
        End If

        Dim pass As String = txtBeginPassword.Text.Trim()
        Dim card As String = If(txtBeginCard.Text.Trim() = "", "0", txtBeginCard.Text.Trim())

        AxBioBridgeSDKv3lib1.SetCardNo(card)
        If AxBioBridgeSDKv3lib1.IsTFT() = 0 Then
            AxBioBridgeSDKv3lib1.BeginBatchUpdate()
            AxBioBridgeSDKv3lib1.SSR_SetUserInfo(txtBeginEnroll.Text.Trim(), "", pass, 0, True)
            AxBioBridgeSDKv3lib1.BatchUpdate()
        Else
            AxBioBridgeSDKv3lib1.BeginBatchUpdate()
            AxBioBridgeSDKv3lib1.SetUserInfo(Convert.ToInt32(txtBeginEnroll.Text.Trim()), "", pass, 0, True)
            AxBioBridgeSDKv3lib1.BatchUpdate()
        End If

        listBox3.Items.Add(("Begin batch update complete."))
    End Sub

    Private Sub btnGatewayGet_Click(sender As Object, e As EventArgs) Handles btnGatewayGet.Click
        Dim Gateway As String = String.Empty
        If AxBioBridgeSDKv3lib1.GetGateway(Gateway) = 0 Then
            listBox3.Items.Add(("Gateway = " & Gateway))
        Else
            listBox3.Items.Add(("Set Gateway Fail"))
        End If

        txtGateway.Text = Gateway
    End Sub

    Private Sub btnGatewaySet_Click(sender As Object, e As EventArgs) Handles btnGatewaySet.Click
        If AxBioBridgeSDKv3lib1.SetGateway(txtGateway.Text.Trim()) = 0 Then
            listBox3.Items.Add(("Set Gateway Success"))
        Else
            listBox3.Items.Add(("Set Gateway Fail"))
        End If
    End Sub

    Private Sub btnSubnetGet_Click(sender As Object, e As EventArgs) Handles btnSubnetGet.Click
        Dim SubnetMask As String = String.Empty
        If AxBioBridgeSDKv3lib1.GetSubnetMask(SubnetMask) = 0 Then
            listBox3.Items.Add(("SubnetMask = " & SubnetMask))
        Else
            listBox3.Items.Add(("Set SubnetMask Fail"))
        End If

        txtSubnet.Text = SubnetMask
    End Sub

    Private Sub btnSubnetSet_Click(sender As Object, e As EventArgs) Handles btnSubnetSet.Click
        If AxBioBridgeSDKv3lib1.SetSubnetMask(txtSubnet.Text.Trim()) = 0 Then
            listBox3.Items.Add(("Set Subnet Mask Success"))
        Else
            listBox3.Items.Add(("Set Subnet Mask Fail"))
        End If
    End Sub

    Private Sub btnPlatform_Click(sender As Object, e As EventArgs) Handles btnPlatform.Click
        Dim Platform As String = String.Empty
        If AxBioBridgeSDKv3lib1.GetPlatform(Platform) = 0 Then
            listBox3.Items.Add(("Platform = " & Platform))
        Else
            listBox3.Items.Add(("Get Platform Fail"))
        End If

        txtPlatform.Text = Platform
    End Sub

    Private Sub btnSleepGet_Click(sender As Object, e As EventArgs) Handles btnSleepGet.Click
        Dim hour As Integer = 0
        Dim min As Integer = 0

        If AxBioBridgeSDKv3lib1.GetSleep(hour, min) = 0 Then
            listBox3.Items.Add(("Sleep time=" & hour & ":" & min))
        Else
            listBox3.Items.Add(("Get Sleep time Fail"))
        End If
        txtSleepH.Text = hour.ToString()
        txtSleepM.Text = min.ToString()
    End Sub

    Private Sub btnSleepSet_Click(sender As Object, e As EventArgs) Handles btnSleepSet.Click
        Dim hour As Integer = Convert.ToInt32(txtSleepH.Text.Trim())
        Dim min As Integer = Convert.ToInt32(txtSleepM.Text.Trim())
        If AxBioBridgeSDKv3lib1.SetSleep(hour, min) = 0 Then
            listBox3.Items.Add(("Set Sleep time success"))
        Else
            listBox3.Items.Add(("Set Sleep time Fail"))
        End If
    End Sub

    Private Sub btnGroupTimezone_Get_Click(sender As Object, e As EventArgs) Handles btnGroupTimezone_Get.Click
        Dim groupid As Integer = Convert.ToInt32(txtGroupTimezone_Group.Text.Trim())
        Dim timezone As String = String.Empty
        Dim verifystyle As String = String.Empty

        If AxBioBridgeSDKv3lib1.GetGroupTimezoneVerify(groupid, timezone, verifystyle) = 0 Then
            listBox3.Items.Add(("Get Group Timezone Verify success"))
        Else
            listBox3.Items.Add(("Get Group Timezone Verify Fail"))
        End If

        txtGroupTimezone_Timezone.Text = timezone
        txtGroupTimezone_Verify.Text = verifystyle
    End Sub

    Private Sub btnGroupTimezone_Set_Click(sender As Object, e As EventArgs) Handles btnGroupTimezone_Set.Click
        Dim groupid As Integer = Convert.ToInt32(txtGroupTimezone_Group.Text.Trim())
        Dim timezone As String = txtGroupTimezone_Timezone.Text.Trim()
        Dim verifystyle As String = txtGroupTimezone_Verify.Text.Trim()

        If AxBioBridgeSDKv3lib1.SetGroupTimezoneVerify(groupid, timezone, verifystyle) = 0 Then
            listBox3.Items.Add(("Set Group Timezone Verify success"))
        Else
            listBox3.Items.Add(("Set Group Timezone Verify Fail"))
        End If


    End Sub
#End Region

#Region "Clear"
    Private Sub btnListBox3Clear_Click(sender As Object, e As EventArgs) Handles btnListBox3Clear.Click
        listBox3.Items.Clear()
    End Sub

    Private Sub btnListBox2Clear_Click(sender As Object, e As EventArgs) Handles btnListBox2Clear.Click
        listBox2.Items.Clear()
    End Sub

    Private Sub btnListBox1Clear_Click(sender As Object, e As EventArgs) Handles btnListBox1Clear.Click
        listBox1.Items.Clear()
    End Sub

    Private Sub button1_Click(sender As Object, e As EventArgs) Handles button1.Click
        List1.Items.Clear()
    End Sub

#End Region

#Region "ACCESS CONTROL"

    Private Sub btnGetEveryWeekTimezone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetEveryWeekTimezone.Click

        Dim ss As String = String.Empty, sTZ As String = String.Empty, sVS As String = String.Empty
        Dim lTextBoxVC__1 As List(Of TextBox) = lTextboxVC()
        'get all start time and end time textbox
        Dim lTextBox__2 As List(Of TextBox) = lTextbox()

        If AxBioBridgeSDKv3lib1.GetEveryWeekTimeZone(Convert.ToInt32(txtDayOfWeek.Text), sTZ, sVS) = 0 Then
            If sVS.Length > 100 Then
                'remove character from index 100 
                sVS = sVS.Remove(100)
            End If
            Dim lTZ As List(Of String) = Enumerable.Range(0, sTZ.Length / 4).[Select](Function(i) sTZ.Substring(i * 4, 4)).ToList()
            'split string by 4 char to list
            Dim lVS As List(Of String) = Enumerable.Range(0, sVS.Length / 2).[Select](Function(i) sVS.Substring(i * 2, 2)).ToList()
            'split string by 2 char to list
            For i As Integer = 0 To lTZ.Count - 1
                '100 item - 50 Start time, 50 End time
                'assign value to respective textbox
                lTextBox__2(i).Text = lTZ(i)
            Next

            For i As Integer = 0 To lVS.Count - 1
                'assign value to respective verifycode textbox
                lTextBoxVC__1(i).Text = lVS(i)
            Next
        End If

    End Sub

    Protected Function lTextboxVC() As List(Of TextBox)
        Dim ltextboxvc__1 As New List(Of TextBox)()

        ltextboxvc__1.Add(txtVc1)
        ltextboxvc__1.Add(txtVc2)
        ltextboxvc__1.Add(txtVc3)
        ltextboxvc__1.Add(txtVc4)
        ltextboxvc__1.Add(txtVc5)
        ltextboxvc__1.Add(txtVc6)
        ltextboxvc__1.Add(txtVc7)
        ltextboxvc__1.Add(txtVc8)
        ltextboxvc__1.Add(txtVc9)
        ltextboxvc__1.Add(txtVc10)

        ltextboxvc__1.Add(txtVc11)
        ltextboxvc__1.Add(txtVc12)
        ltextboxvc__1.Add(txtVc13)
        ltextboxvc__1.Add(txtVc14)
        ltextboxvc__1.Add(txtVc15)
        ltextboxvc__1.Add(txtVc16)
        ltextboxvc__1.Add(txtVc17)
        ltextboxvc__1.Add(txtVc18)
        ltextboxvc__1.Add(txtVc19)
        ltextboxvc__1.Add(txtVc20)

        ltextboxvc__1.Add(txtVc21)
        ltextboxvc__1.Add(txtVc22)
        ltextboxvc__1.Add(txtVc23)
        ltextboxvc__1.Add(txtVc24)
        ltextboxvc__1.Add(txtVc25)
        ltextboxvc__1.Add(txtVc26)
        ltextboxvc__1.Add(txtVc27)
        ltextboxvc__1.Add(txtVc28)
        ltextboxvc__1.Add(txtVc29)
        ltextboxvc__1.Add(txtVc30)

        ltextboxvc__1.Add(txtVc31)
        ltextboxvc__1.Add(txtVc32)
        ltextboxvc__1.Add(txtVc33)
        ltextboxvc__1.Add(txtVc34)
        ltextboxvc__1.Add(txtVc35)
        ltextboxvc__1.Add(txtVc36)
        ltextboxvc__1.Add(txtVc37)
        ltextboxvc__1.Add(txtVc38)
        ltextboxvc__1.Add(txtVc39)
        ltextboxvc__1.Add(txtVc40)

        ltextboxvc__1.Add(txtVc41)
        ltextboxvc__1.Add(txtVc42)
        ltextboxvc__1.Add(txtVc43)
        ltextboxvc__1.Add(txtVc44)
        ltextboxvc__1.Add(txtVc45)
        ltextboxvc__1.Add(txtVc46)
        ltextboxvc__1.Add(txtVc47)
        ltextboxvc__1.Add(txtVc48)
        ltextboxvc__1.Add(txtVc49)
        ltextboxvc__1.Add(txtVc50)

        Return ltextboxvc__1
    End Function

    Protected Function lTextbox() As List(Of TextBox)
        Dim lTxtBox As New List(Of TextBox)()

        lTxtBox.Add(txtSt1)
        lTxtBox.Add(txtEt1)
        lTxtBox.Add(txtSt2)
        lTxtBox.Add(txtEt2)
        lTxtBox.Add(txtSt3)
        lTxtBox.Add(txtEt3)
        lTxtBox.Add(txtSt4)
        lTxtBox.Add(txtEt4)
        lTxtBox.Add(txtSt5)
        lTxtBox.Add(txtEt5)
        lTxtBox.Add(txtSt6)
        lTxtBox.Add(txtEt6)
        lTxtBox.Add(txtSt7)
        lTxtBox.Add(txtEt7)
        lTxtBox.Add(txtSt8)
        lTxtBox.Add(txtEt8)
        lTxtBox.Add(txtSt9)
        lTxtBox.Add(txtEt9)
        lTxtBox.Add(txtSt10)
        lTxtBox.Add(txtEt10)

        lTxtBox.Add(txtSt11)
        lTxtBox.Add(txtEt11)
        lTxtBox.Add(txtSt12)
        lTxtBox.Add(txtEt12)
        lTxtBox.Add(txtSt13)
        lTxtBox.Add(txtEt13)
        lTxtBox.Add(txtSt14)
        lTxtBox.Add(txtEt14)
        lTxtBox.Add(txtSt15)
        lTxtBox.Add(txtEt15)
        lTxtBox.Add(txtSt16)
        lTxtBox.Add(txtEt16)
        lTxtBox.Add(txtSt17)
        lTxtBox.Add(txtEt17)
        lTxtBox.Add(txtSt18)
        lTxtBox.Add(txtEt18)
        lTxtBox.Add(txtSt19)
        lTxtBox.Add(txtEt19)
        lTxtBox.Add(txtSt20)
        lTxtBox.Add(txtEt20)

        lTxtBox.Add(txtSt21)
        lTxtBox.Add(txtEt21)
        lTxtBox.Add(txtSt22)
        lTxtBox.Add(txtEt22)
        lTxtBox.Add(txtSt23)
        lTxtBox.Add(txtEt23)
        lTxtBox.Add(txtSt24)
        lTxtBox.Add(txtEt24)
        lTxtBox.Add(txtSt25)
        lTxtBox.Add(txtEt25)
        lTxtBox.Add(txtSt26)
        lTxtBox.Add(txtEt26)
        lTxtBox.Add(txtSt27)
        lTxtBox.Add(txtEt27)
        lTxtBox.Add(txtSt28)
        lTxtBox.Add(txtEt28)
        lTxtBox.Add(txtSt29)
        lTxtBox.Add(txtEt29)
        lTxtBox.Add(txtSt30)
        lTxtBox.Add(txtEt30)

        lTxtBox.Add(txtSt31)
        lTxtBox.Add(txtEt31)
        lTxtBox.Add(txtSt32)
        lTxtBox.Add(txtEt32)
        lTxtBox.Add(txtSt33)
        lTxtBox.Add(txtEt33)
        lTxtBox.Add(txtSt34)
        lTxtBox.Add(txtEt34)
        lTxtBox.Add(txtSt35)
        lTxtBox.Add(txtEt35)
        lTxtBox.Add(txtSt36)
        lTxtBox.Add(txtEt36)
        lTxtBox.Add(txtSt37)
        lTxtBox.Add(txtEt37)
        lTxtBox.Add(txtSt38)
        lTxtBox.Add(txtEt38)
        lTxtBox.Add(txtSt39)
        lTxtBox.Add(txtEt39)
        lTxtBox.Add(txtSt40)
        lTxtBox.Add(txtEt40)

        lTxtBox.Add(txtSt41)
        lTxtBox.Add(txtEt41)
        lTxtBox.Add(txtSt42)
        lTxtBox.Add(txtEt42)
        lTxtBox.Add(txtSt43)
        lTxtBox.Add(txtEt43)
        lTxtBox.Add(txtSt44)
        lTxtBox.Add(txtEt44)
        lTxtBox.Add(txtSt45)
        lTxtBox.Add(txtEt45)
        lTxtBox.Add(txtSt46)
        lTxtBox.Add(txtEt46)
        lTxtBox.Add(txtSt47)
        lTxtBox.Add(txtEt47)
        lTxtBox.Add(txtSt48)
        lTxtBox.Add(txtEt48)
        lTxtBox.Add(txtSt49)
        lTxtBox.Add(txtEt49)
        lTxtBox.Add(txtSt50)
        lTxtBox.Add(txtEt50)

        Return lTxtBox
    End Function

    Private Sub btnSetEveryWeekTimezone_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetEveryWeekTimezone.Click
        If txtDayOfWeek.Text <> "" Then
            Dim sTimeZone As String = String.Empty
            Dim sVerifyCode As String = String.Empty
            Dim iDayOfWeek As Integer = Convert.ToInt32(txtDayOfWeek.Text)
            sTimeZone = GetEveryTimeZone(lEveryTimezoneToList())
            sVerifyCode = GetVerifyCodeEveryTimezone(lVerifyCodeEveryTimezone())

            If AxBioBridgeSDKv3lib1.SetEveryWeekTimeZone(iDayOfWeek, sTimeZone, sVerifyCode) = 0 Then
                MessageBox.Show("SetEveryWeekTimeZone Successful")
            Else
                MessageBox.Show("SetEveryWeekTimeZone failed")
            End If
        Else
            MessageBox.Show("Day of week is empty")
        End If

    End Sub

    Protected Function GetEveryTimeZone(ByVal lEveryTimezone As List(Of String)) As String
        Dim sEveryTimezone As String = String.Empty

        For Each sTimezone As String In lEveryTimezone
            sEveryTimezone += sTimezone
        Next

        Return sEveryTimezone
    End Function

    Protected Function lEveryTimezoneToList() As List(Of String)
        Dim lTimezone As New List(Of String)()
        lTimezone.Add(txtSt1.Text)
        lTimezone.Add(txtEt1.Text)
        lTimezone.Add(txtSt2.Text)
        lTimezone.Add(txtEt2.Text)
        lTimezone.Add(txtSt3.Text)
        lTimezone.Add(txtEt3.Text)
        lTimezone.Add(txtSt4.Text)
        lTimezone.Add(txtEt4.Text)
        lTimezone.Add(txtSt5.Text)
        lTimezone.Add(txtEt5.Text)
        lTimezone.Add(txtSt6.Text)
        lTimezone.Add(txtEt6.Text)
        lTimezone.Add(txtSt7.Text)
        lTimezone.Add(txtEt7.Text)
        lTimezone.Add(txtSt8.Text)
        lTimezone.Add(txtEt8.Text)
        lTimezone.Add(txtSt9.Text)
        lTimezone.Add(txtEt9.Text)
        lTimezone.Add(txtSt10.Text)
        lTimezone.Add(txtEt10.Text)

        lTimezone.Add(txtSt11.Text)
        lTimezone.Add(txtEt11.Text)
        lTimezone.Add(txtSt12.Text)
        lTimezone.Add(txtEt12.Text)
        lTimezone.Add(txtSt13.Text)
        lTimezone.Add(txtEt13.Text)
        lTimezone.Add(txtSt14.Text)
        lTimezone.Add(txtEt14.Text)
        lTimezone.Add(txtSt15.Text)
        lTimezone.Add(txtEt15.Text)
        lTimezone.Add(txtSt16.Text)
        lTimezone.Add(txtEt16.Text)
        lTimezone.Add(txtSt17.Text)
        lTimezone.Add(txtEt17.Text)
        lTimezone.Add(txtSt18.Text)
        lTimezone.Add(txtEt18.Text)
        lTimezone.Add(txtSt19.Text)
        lTimezone.Add(txtEt19.Text)
        lTimezone.Add(txtSt20.Text)
        lTimezone.Add(txtEt20.Text)

        lTimezone.Add(txtSt21.Text)
        lTimezone.Add(txtEt21.Text)
        lTimezone.Add(txtSt22.Text)
        lTimezone.Add(txtEt22.Text)
        lTimezone.Add(txtSt23.Text)
        lTimezone.Add(txtEt23.Text)
        lTimezone.Add(txtSt24.Text)
        lTimezone.Add(txtEt24.Text)
        lTimezone.Add(txtSt25.Text)
        lTimezone.Add(txtEt25.Text)
        lTimezone.Add(txtSt26.Text)
        lTimezone.Add(txtEt26.Text)
        lTimezone.Add(txtSt27.Text)
        lTimezone.Add(txtEt27.Text)
        lTimezone.Add(txtSt28.Text)
        lTimezone.Add(txtEt28.Text)
        lTimezone.Add(txtSt29.Text)
        lTimezone.Add(txtEt29.Text)
        lTimezone.Add(txtSt30.Text)
        lTimezone.Add(txtEt30.Text)

        lTimezone.Add(txtSt31.Text)
        lTimezone.Add(txtEt31.Text)
        lTimezone.Add(txtSt32.Text)
        lTimezone.Add(txtEt32.Text)
        lTimezone.Add(txtSt33.Text)
        lTimezone.Add(txtEt33.Text)
        lTimezone.Add(txtSt34.Text)
        lTimezone.Add(txtEt34.Text)
        lTimezone.Add(txtSt35.Text)
        lTimezone.Add(txtEt35.Text)
        lTimezone.Add(txtSt36.Text)
        lTimezone.Add(txtEt36.Text)
        lTimezone.Add(txtSt37.Text)
        lTimezone.Add(txtEt37.Text)
        lTimezone.Add(txtSt38.Text)
        lTimezone.Add(txtEt38.Text)
        lTimezone.Add(txtSt39.Text)
        lTimezone.Add(txtEt39.Text)
        lTimezone.Add(txtSt40.Text)
        lTimezone.Add(txtEt40.Text)

        lTimezone.Add(txtSt41.Text)
        lTimezone.Add(txtEt41.Text)
        lTimezone.Add(txtSt42.Text)
        lTimezone.Add(txtEt42.Text)
        lTimezone.Add(txtSt43.Text)
        lTimezone.Add(txtEt43.Text)
        lTimezone.Add(txtSt44.Text)
        lTimezone.Add(txtEt44.Text)
        lTimezone.Add(txtSt45.Text)
        lTimezone.Add(txtEt45.Text)
        lTimezone.Add(txtSt46.Text)
        lTimezone.Add(txtEt46.Text)
        lTimezone.Add(txtSt47.Text)
        lTimezone.Add(txtEt47.Text)
        lTimezone.Add(txtSt48.Text)
        lTimezone.Add(txtEt48.Text)
        lTimezone.Add(txtSt49.Text)
        lTimezone.Add(txtEt49.Text)
        lTimezone.Add(txtSt50.Text)
        lTimezone.Add(txtEt50.Text)

        Return lTimezone
    End Function

    Protected Function GetVerifyCodeEveryTimezone(ByVal lVerifyCode As List(Of String)) As String
        Dim sVerifyCode As String = String.Empty

        For Each sVc As String In lVerifyCode
            sVerifyCode += sVc
        Next

        Return sVerifyCode
    End Function

    Protected Function lVerifyCodeEveryTimezone() As List(Of String)
        Dim lVerifyCode As New List(Of String)()

        lVerifyCode.Add(txtVc1.Text)
        lVerifyCode.Add(txtVc2.Text)
        lVerifyCode.Add(txtVc3.Text)
        lVerifyCode.Add(txtVc4.Text)
        lVerifyCode.Add(txtVc5.Text)
        lVerifyCode.Add(txtVc6.Text)
        lVerifyCode.Add(txtVc7.Text)
        lVerifyCode.Add(txtVc8.Text)
        lVerifyCode.Add(txtVc9.Text)
        lVerifyCode.Add(txtVc10.Text)

        lVerifyCode.Add(txtVc11.Text)
        lVerifyCode.Add(txtVc12.Text)
        lVerifyCode.Add(txtVc13.Text)
        lVerifyCode.Add(txtVc14.Text)
        lVerifyCode.Add(txtVc15.Text)
        lVerifyCode.Add(txtVc16.Text)
        lVerifyCode.Add(txtVc17.Text)
        lVerifyCode.Add(txtVc18.Text)
        lVerifyCode.Add(txtVc19.Text)
        lVerifyCode.Add(txtVc20.Text)

        lVerifyCode.Add(txtVc21.Text)
        lVerifyCode.Add(txtVc22.Text)
        lVerifyCode.Add(txtVc23.Text)
        lVerifyCode.Add(txtVc24.Text)
        lVerifyCode.Add(txtVc25.Text)
        lVerifyCode.Add(txtVc26.Text)
        lVerifyCode.Add(txtVc27.Text)
        lVerifyCode.Add(txtVc28.Text)
        lVerifyCode.Add(txtVc29.Text)
        lVerifyCode.Add(txtVc30.Text)

        lVerifyCode.Add(txtVc31.Text)
        lVerifyCode.Add(txtVc32.Text)
        lVerifyCode.Add(txtVc33.Text)
        lVerifyCode.Add(txtVc34.Text)
        lVerifyCode.Add(txtVc35.Text)
        lVerifyCode.Add(txtVc36.Text)
        lVerifyCode.Add(txtVc37.Text)
        lVerifyCode.Add(txtVc38.Text)
        lVerifyCode.Add(txtVc39.Text)
        lVerifyCode.Add(txtVc40.Text)

        lVerifyCode.Add(txtVc41.Text)
        lVerifyCode.Add(txtVc42.Text)
        lVerifyCode.Add(txtVc43.Text)
        lVerifyCode.Add(txtVc44.Text)
        lVerifyCode.Add(txtVc45.Text)
        lVerifyCode.Add(txtVc46.Text)
        lVerifyCode.Add(txtVc47.Text)
        lVerifyCode.Add(txtVc48.Text)
        lVerifyCode.Add(txtVc49.Text)
        lVerifyCode.Add(txtVc50.Text)

        Return lVerifyCode
    End Function

    Private Sub btnGetHolidayParam_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGetHolidayParam.Click
        Dim iTZ As Integer = 0, iStartM As Integer = 0, iStartD As Integer = 0, iEndM As Integer = 0, iEndD As Integer = 0, iHolidayId As Integer = 0
        iHolidayId = Convert.ToInt32(txtHolidayParamId.Text)

        If AxBioBridgeSDKv3lib1.GetHolidayParam(1, iTZ, iStartM, iStartD, iEndM, iEndD) = 0 Then
            txtTZHolidayParam.Text = iTZ.ToString()
            txtStartMonth.Text = iStartM.ToString()
            txtStartDay.Text = iStartD.ToString()
            txtEndMonth.Text = iEndM.ToString()
            txtEndDay.Text = iEndD.ToString()
        End If
    End Sub

    Private Sub btnSetHolidayParam_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetHolidayParam.Click
        If Not (txtHolidayParamId.Text = "" OrElse txtTZHolidayParam.Text = "" OrElse txtStartMonth.Text = "" OrElse txtStartDay.Text = "" OrElse txtEndMonth.Text = "" OrElse txtEndDay.Text = "") Then
            Dim iHolidayid As Integer = Convert.ToInt32(txtHolidayParamId.Text)
            Dim iTimezoneId As Integer = Convert.ToInt32(txtTZHolidayParam.Text)
            Dim iSM As Integer = Convert.ToInt32(txtStartMonth.Text)
            Dim iSD As Integer = Convert.ToInt32(txtStartDay.Text)
            Dim iEM As Integer = Convert.ToInt32(txtEndMonth.Text)
            Dim iED As Integer = Convert.ToInt32(txtEndDay.Text)

            AxBioBridgeSDKv3lib1.SetHolidayParam(iHolidayid, iTimezoneId, iSM, iSD, iEM, iED)
        Else
            MessageBox.Show("required field not fill in")
        End If
    End Sub
#End Region


End Class
