Imports System.Collections.Generic
Imports System.Linq
Imports System.Windows.Forms

NotInheritable Class Program
	Private Sub New()
	End Sub
	''' <summary>
	''' The main entry point for the application.
	''' </summary>
	<STAThread> _
	Friend Shared Sub Main()

		Application.SetUnhandledExceptionMode(UnhandledExceptionMode.CatchException)
		' Set the unhandled exception mode to force all Windows Forms errors to go through our handler.
		AddHandler AppDomain.CurrentDomain.UnhandledException, New UnhandledExceptionEventHandler(AddressOf Applicationn_UnhandledException)


		Application.EnableVisualStyles()
		Application.SetCompatibleTextRenderingDefault(False)
		Application.Run(New Form1())
	End Sub

	Private Shared Sub Applicationn_UnhandledException(sender As Object, e As UnhandledExceptionEventArgs)
		Dim ex As Exception = DirectCast(e.ExceptionObject, Exception)
		MessageBox.Show(ex.Message.ToString())


	End Sub
End Class
